clear all; close all; clc;
workPath = ['F:\SharedCFD\FinishedSimulation\cases\'];
fileOpen = dir(workPath);
nFile    = size(fileOpen,1)-2;
for i=1:nFile
fileName{i} = fileOpen(i+2).name;
end
fileName=fileName';

for i=1:nFile
   a=[fileName{i}];
   if a(19:21)=='050'
       database_cfd(i).object=['BB1'];
   elseif a(19:21)=='075'
       database_cfd(i).object=['BB2'];
   else
       database_cfd(i).object=['BB3'];
   end
   database_cfd(i).amplitude  =str2num(a(33:34));
   database_cfd(i).period =str2num(a(38:41)); Om=2*pi/database_cfd(i).period;
   t_step =database_cfd(i).period/str2num(a(46:49));
   database_cfd(i).t_imposed=[t_step:t_step:(20*database_cfd(i).period)]';
   
   database_cfd(i).eta4_imposed=database_cfd(i).amplitude*sin(Om*database_cfd(i).t_imposed);
   database_cfd(i).eta4_imposed(find(database_cfd(i).t_imposed<=(5*database_cfd(i).period)))...
       =(database_cfd(i).t_imposed(find(database_cfd(i).t_imposed<=(5*database_cfd(i).period)))...
       /(5*database_cfd(i).period)).*database_cfd(i).eta4_imposed(find(database_cfd(i).t_imposed<=(5*database_cfd(i).period)));
   database_cfd(i).eta4dot_imposed=gradient(database_cfd(i).eta4_imposed,t_step);
   database_cfd(i).eta4dotdot_imposed=gradient(database_cfd(i).eta4dot_imposed,t_step);
   
   caseName1 = [workPath a '\postProcessing\forceBKL\0\forces.dat'];
   caseName2 = [workPath a '\postProcessing\forceBKLdyn\0\forces.dat'];
   caseName3 = [workPath a '\postProcessing\forceBKR\0\forces.dat'];
   caseName4 = [workPath a '\postProcessing\forceBKRdyn\0\forces.dat'];
   caseName5 = [workPath a '\postProcessing\forceHull\0\forces.dat'];
   caseName6 = [workPath a '\postProcessing\forceHulldyn\0\forces.dat'];
   caseName7 = [workPath a '\postProcessing\forceTotal\0\forces.dat'];
   caseName8 = [workPath a '\postProcessing\forceTotaldyn\0\forces.dat'];
   caseName9 = [workPath a '\postProcessing\probeSurfLeft\0\p_gh'];
   caseName10 = [workPath a '\postProcessing\probeSurfRight\0\p_gh'];
   [time_postproc,M44_Totaldyn] = rollmomimport(caseName8);
   [Fx_BKLdyn,Fy_BKLdyn,Fz_BKLdyn] = forceimport(caseName2);
   [Fx_BKRdyn,Fy_BKRdyn,Fz_BKRdyn] = forceimport(caseName4);
   [Time_pr_left,pgh_left04,pgh_left24] = importfile3(caseName9, 5, 5000000);
   [Time_pr_right,pgh_right04,pgh_right24] = importfile2(caseName10,5, 5000000);
   
   database_cfd(i).t_postproc=time_postproc;
   database_cfd(i).M_Totaldyn=M44_Totaldyn;
   database_cfd(i).Fx_BKLdyn=Fx_BKLdyn;
   database_cfd(i).Fy_BKLdyn=Fy_BKLdyn;
   database_cfd(i).Fz_BKLdyn=Fz_BKLdyn;
   database_cfd(i).Fx_BKRdyn=Fx_BKRdyn;
   database_cfd(i).Fy_BKRdyn=Fy_BKRdyn;
   database_cfd(i).Fz_BKRdyn=Fz_BKRdyn;   
   database_cfd(i).pgh_left04=pgh_left04;
   database_cfd(i).pgh_left24=pgh_left24;
   database_cfd(i).pgh_right04=pgh_right04;
   database_cfd(i).pgh_right24=pgh_right24;
end