function generateRun(mainfolder,campaign,Allrun)
    workPath = [mainfolder campaign '\\cases'];
    FinishSimPath = [mainfolder campaign '\\FinishSim'];
    meshPath1 = 'F:\\SharedCFD\\MeshFile\\mukhlas\\mesh\\squareAppen\\domainboxApp';
%   meshPath2 = 'F:\\SharedCFD\\MeshFile\\mukhlas\\mesh\\cases';
%     meshDim = char('D050S28','D075S28','D100S28'); 
    meshDim = char('D050S28'); 
    Refinement = char('6');    
    sourcePath = [mainfolder campaign];
    templatePath = [sourcePath '\\' 'template'];
    
    k=1;
    for i=1:size(meshDim,1)
      for j=1:size(Refinement,1)
          meshPath(k,:)=[meshPath1 meshDim(i,:) '_R' Refinement(j,:)];
          k=k+1;
      end
    end
           
    Theta=[3,8,13];
    Ts =1.0;
    dtPerT = [1000,2000,4000];
%     Theta=[2:6:14];
%     Ts =[0.9:0.55:2];
%     dtPerT = [500,1000,2000,3000];
    
    for ind1 = 1:length(Ts)
        for ind2 = 1:length(Theta)
            for ind3 = 1:length(dtPerT)
                for ind4 = 1:size(meshPath,1)
                
                %input parameters
                inputs.T = Ts(ind1);
                inputs.dtPerT = dtPerT(ind3);
                inputs.Theta = Theta(ind2);
                inputs.writePrtT = 3;
        
                caseName = ['case_' meshPath(ind4,54:75) '_Amp_' num2str(inputs.Theta,'%02i') '_T_' num2str(inputs.T,'%.2f') '_TS_' num2str(inputs.dtPerT,'%04i')];
        
                casePath = [workPath '\\' caseName];
                meshcasePath = [casePath '\\' 'constant'];
                copyPath1 = ['/media/sf_SharedCFD/' campaign '/cases/' caseName];
                copyPath2 = ['/media/sf_SharedCFD/' campaign '/FinishSim/' caseName];
                finishSim1 = ['/home/mukhlas/ForcedRoll/' campaign '/cases/' caseName];
                finishSim2 = ['/home/mukhlas/ForcedRoll/' campaign '/cases/' caseName '_done'];
                mkdir(casePath);
                copyfile([templatePath '\\*'], casePath);
                copyfile([meshPath(ind4,:) '\\constant' '\\*'], meshcasePath);

                applyInput(casePath, inputs);
                fprintf(Allrun,'(cd cases/%s && ./Allrun) \n',caseName);
                fprintf(Allrun,'mv %s %s \n \n \n',finishSim1,finishSim2);
%                 fprintf(Allrun,'cp -r %s %s \n',copyPath1,copyPath2);
%                 fprintf(Allrun,'rm -rf %s  \n \n \n',copyPath1);
                end
            end
        end
    end
end


function applyInput(casePath, inputs)

    
%     UFile = fullfile(casePath,'0','U');
%     params={};
%     param.name = '__rollAmp__';
%     param.value = inputs.amp;   
%     params{end+1} = param;
% 
%     param2.name = '__rollOmega__';
%     param2.value = inputs.T;   
%     params{end+1} = param2;
  
    %---------------------------------------------------------------------  
    % Control Dictionary file
    file1 = fullfile(casePath,'system','controlDict');
    params1={};

    param1.name = '__endTime__';
    param1.value = inputs.T*20;   
    params1{end+1} = param1;
    
    param2.name = '__deltaT__';
    param2.value = inputs.T/inputs.dtPerT;   
    params1{end+1} = param2;
    
    param3.name = '__writeInterval__';
    param3.value = inputs.T/inputs.writePrtT;   
    params1{end+1} = param3;

    replaceParams(file1,params1);
    %---------------------------------------------------------------------
    % Point Displacement File
    file2 = fullfile(casePath,'0','pointDisplacement');
    params2={};
    
    param4.name = '__rampDurationRoll__';
    param4.value = (inputs.T)*5;   
    params2{end+1} = param4;
    
    param5.name = '__finalRollAmp__';
    param5.value = inputs.Theta;   
    params2{end+1} = param5; 
    
    param6.name = '__rollOmega__';
    param6.value = 2*pi/inputs.T;   
    params2{end+1} = param6; 
   

    replaceParams(file2,params2);
    %---------------------------------------------------------------------    
end

function replaceParams(filePath, params)

     txt = fileread(filePath);

    for ind = 1:length(params)
        param = params{ind};
        txt = strrep(txt, param.name,num2str(param.value));
    end     

    fid = fopen(filePath,'wt');
    fprintf(fid, '%s', txt);
    fclose(fid); 
end