/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | Copyright (C) 2012 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "fixedValuePointPatchFieldTemplate.H"
#include "addToRunTimeSelectionTable.H"
#include "pointPatchFieldMapper.H"
#include "pointFields.H"
#include "unitConversion.H"
//{{{ begin codeInclude
#line 56 "/media/sf_SharedCFD/A14T100/0/pointDisplacement.boundaryField.hull.*|bk.*"
#include "OFstream.H"
		#include "interpolationTable.H"
//}}} end codeInclude


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{

// * * * * * * * * * * * * * * * Local Functions * * * * * * * * * * * * * * //

//{{{ begin localCode

//}}} end localCode


// * * * * * * * * * * * * * * * Global Functions  * * * * * * * * * * * * * //

extern "C"
{
    // dynamicCode:
    // SHA1 = 6ec8265ef6bebd314be442d763468a0977e0cb58
    //
    // unique function name that can be checked if the correct library version
    // has been loaded
    void dispHull_6ec8265ef6bebd314be442d763468a0977e0cb58(bool load)
    {
        if (load)
        {
            // code that can be explicitly executed after loading
        }
        else
        {
            // code that can be explicitly executed before unloading
        }
    }
}

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

makePointPatchTypeField
(
    pointPatchVectorField,
    dispHullFixedValuePointPatchVectorField
);


const char* const dispHullFixedValuePointPatchVectorField::SHA1sum =
    "6ec8265ef6bebd314be442d763468a0977e0cb58";


// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

dispHullFixedValuePointPatchVectorField::
dispHullFixedValuePointPatchVectorField
(
    const pointPatch& p,
    const DimensionedField<vector, pointMesh>& iF
)
:
    fixedValuePointPatchField<vector>(p, iF)
{
    if (false)
    {
        Info<<"construct dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58"
            " from patch/DimensionedField\n";
    }
}


dispHullFixedValuePointPatchVectorField::
dispHullFixedValuePointPatchVectorField
(
    const dispHullFixedValuePointPatchVectorField& ptf,
    const pointPatch& p,
    const DimensionedField<vector, pointMesh>& iF,
    const pointPatchFieldMapper& mapper
)
:
    fixedValuePointPatchField<vector>(ptf, p, iF, mapper)
{
    if (false)
    {
        Info<<"construct dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58"
            " from patch/DimensionedField/mapper\n";
    }
}


dispHullFixedValuePointPatchVectorField::
dispHullFixedValuePointPatchVectorField
(
    const pointPatch& p,
    const DimensionedField<vector, pointMesh>& iF,
    const dictionary& dict,
    const bool valueRequired
)
:
    fixedValuePointPatchField<vector>(p, iF, dict, valueRequired)
{
    if (false)
    {
        Info<<"construct dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58"
            " from patch/dictionary\n";
    }
}


dispHullFixedValuePointPatchVectorField::
dispHullFixedValuePointPatchVectorField
(
    const dispHullFixedValuePointPatchVectorField& ptf
)
:
    fixedValuePointPatchField<vector>(ptf)
{
    if (false)
    {
        Info<<"construct dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58"
            " as copy\n";
    }
}


dispHullFixedValuePointPatchVectorField::
dispHullFixedValuePointPatchVectorField
(
    const dispHullFixedValuePointPatchVectorField& ptf,
    const DimensionedField<vector, pointMesh>& iF
)
:
    fixedValuePointPatchField<vector>(ptf, iF)
{
    if (false)
    {
        Info<<"construct dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58 "
            "as copy/DimensionedField\n";
    }
}


// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //

dispHullFixedValuePointPatchVectorField::
~dispHullFixedValuePointPatchVectorField()
{
    if (false)
    {
        Info<<"destroy dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58\n";
    }
}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void dispHullFixedValuePointPatchVectorField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    if (false)
    {
        Info<<"updateCoeffs dispHull sha1: 6ec8265ef6bebd314be442d763468a0977e0cb58\n";
    }

//{{{ begin code
    #line 62 "/media/sf_SharedCFD/A14T100/0/pointDisplacement.boundaryField.hull.*|bk.*"
/*input parameters */
		scalar rampStartTimeRoll 	= 0.0;
		scalar rampDurationRoll		= 5;
		scalar rampEndTimeRoll		= rampStartTimeRoll + rampDurationRoll;
		scalar rampStartValueRoll 	= 0.0;

		scalar rampStartTimeSway 	= 0.0;
		scalar rampDurationSway		= 0.0;
		scalar rampEndTimeSway		= rampStartTimeSway + rampDurationSway;
		scalar rampStartValueSway 	= 0.0;

		scalar rampStartTimeHeave 	= 0.0;
		scalar rampDurationHeave	= 0.0;
		scalar rampEndTimeHeave		= rampStartTimeHeave + rampDurationHeave;
		scalar rampStartValueHeave 	= 0.0;

		scalar finalRollAmp 	= 14.0;	
		scalar finalSwayAmp 	= 0.0;
		scalar finalHeaveAmp 	= 0.0;

		scalar rollOmega	= 6.28318530718;
		scalar swayOmega	= 6.28318530718;
		scalar heaveOmega	= 6.28318530718;

		scalar rollPhase 	= 0.0;
		scalar swayPhase 	= 0.0;
		scalar heavePhase 	= 0.0;

		vector rotationCenter(0.0,0.0,-0.0144);
		vector rotationAxis(1,0,0);
		
		/*getting current time*/
		scalar curTime = this->db().time().value();
		word patchName = this->patch().name();
		
		/*ramp implimentation */
		scalar rollAmp = 0;
		scalar swayAmp = 0;
		scalar heaveAmp = 0;
		
		if (curTime < rampStartTimeRoll) {
			rollAmp = rampStartValueRoll;
		}
		else if (curTime <= rampEndTimeRoll) {
			rollAmp = (finalRollAmp - rampStartValueRoll)/rampDurationRoll * (curTime - rampStartTimeRoll) + rampStartValueRoll;
		}
		else if (curTime > rampEndTimeRoll){
			rollAmp = finalRollAmp;
		}

		/*changing degrees to radiens*/
		rollAmp = rollAmp * Foam::constant::mathematical::pi/180.0;

		/* aminus is added to correct the direction, compensate for the sign in rotation matrix*/
		vector rollDisp(0.0,0.0,0.0);
			rollDisp = -rollAmp * Foam::sin( rollOmega * curTime + rollPhase) * rotationAxis;

		vector swayDisp(0.0,0.0,0.0);
		vector swayAxis(1.0,0.0,0.0);
			swayDisp = swayAmp * Foam::sin( swayOmega * curTime + swayPhase) * swayAxis;

		vector heaveDisp(0.0,0.0,0.0);
		vector heaveAxis(0.0,0.0,1.0);
			heaveDisp = heaveAmp * Foam::sin( heaveOmega * curTime + heavePhase) * heaveAxis;

		/**/
		vectorField points(patch().localPoints());
		
		if (points.size() == 0 )
            return;		
		
		std::ostringstream points0OutFile;
		points0OutFile << "./constant/boundaryData/" << this->db().caseName().name() << patchName << "_points0.tab";

		if (curTime == this->db().time().deltaT0Value()) {
			Info << "writing orginal points." << endl;
			OFstream pointsFileStream(points0OutFile.str());
			pointsFileStream << points;
			pointsFileStream.flush();
		}
		/* load original shape */
		IFstream pointsFileIStream(points0OutFile.str());
		pointsFileIStream >> points;

		vectorField bodyPointsDisp(points.size(), vector(0,0,0));
		for (label i=0; i<bodyPointsDisp.size(); i++) {
		bodyPointsDisp[i].y() = ( 
				  	    Foam::cos(rollDisp.x()) * (points[i].y() - rotationCenter.y()) 
				     + 	Foam::sin(rollDisp.x()) * (points[i].z() - rotationCenter.z()) 
				     	 	 	 )
				     +  rotationCenter.y() + swayDisp.y() - points[i].y();
		bodyPointsDisp[i].z() = ( 
					 -	Foam::sin(rollDisp.x()) * (points[i].y() - rotationCenter.y()) 
				     + 	Foam::cos(rollDisp.x()) * (points[i].z() - rotationCenter.z()) 
				     	 	 	 )
				     +  rotationCenter.z() + heaveDisp.z() - points[i].z();
		}
		
		/*Adjusting for free-surface cut*/
		
		scalar draft = 0.16;
		scalar beam = 0.5;
		scalar bR = 0.0;
		scalar cutLen = 0.95 * (draft - bR);
		scalar zCut = - cutLen;
		
		vector leftTop(0.0, -beam/2.0, 0.0);
		vector leftBot(0.0, -beam/2.0, zCut);

		vector rightTop(0.0, beam/2.0, 0.0);
		vector rightBot(0.0, beam/2.0, zCut);

		/*finding the points on the two side lines and bottom*/
		
		std::ostringstream pntLocFileName;
		pntLocFileName << "./constant/boundaryData/" << this->db().caseName().name() << patchName << "_pntloc.tab";
		List<Tuple2<scalar, scalar> > pntList(points.size());

		/*generate the table for first time step, read it later*/
		if (curTime == this->db().time().deltaT0Value()) {
			for (label i=0; i<points.size(); i++) {
				pntList[i].first() = i;
				
				if (points[i].z() <= zCut) {
					pntList[i].second() = 0.0;
				}
				else {
					if (points[i].y() < 0) {
						scalar dist = sqrt(
								sqr(points[i].y() - leftTop.y()) + 
								sqr(points[i].z() - leftTop.z())
								);
						pntList[i].second() = 1.0 + dist/cutLen;
						 
					}
					else {
						scalar dist = sqrt(
								sqr(points[i].y() - rightTop.y()) + 
								sqr(points[i].z() - rightTop.z())
								);
						pntList[i].second() = 3.0 + dist/cutLen;
					}
				}
			}
			
			OFstream pntFileStream(fileName(pntLocFileName.str()));
			interpolationTable<scalar> pntTab(pntList, 
					interpolationTable<scalar>::CLAMP, pntLocFileName.str());
			pntFileStream << pntTab;
			pntFileStream.flush();
		}

		
		interpolationTable<scalar> pntTab(pntLocFileName.str());		
		pntTab.outOfBounds(interpolationTable<scalar>::CLAMP);
		
		/*finding new locations for lines' points */
		
		vector newTopL(0,0,0);
		newTopL.y() = ( Foam::cos(rollDisp.x()) * (leftTop.y() - rotationCenter.y()) 
			      	  + Foam::sin(rollDisp.x()) * (leftTop.z() - rotationCenter.z()) )
			      	  + rotationCenter.y() + swayDisp.y();
		newTopL.z() = (- Foam::sin(rollDisp.x()) * (leftTop.y() - rotationCenter.y()) 
			      	  + Foam::cos(rollDisp.x()) * (leftTop.z() - rotationCenter.z()) )
			      	  + rotationCenter.z() + heaveDisp.z() ;

		vector newBotL(0,0,0);
		newBotL.y() = ( Foam::cos(rollDisp.x()) * (leftBot.y() - rotationCenter.y()) 
			      	  + Foam::sin(rollDisp.x()) * (leftBot.z() - rotationCenter.z()) )
			      	  + rotationCenter.y() + swayDisp.y();
		newBotL.z() = (- Foam::sin(rollDisp.x()) * (leftBot.y() - rotationCenter.y()) 
				      + Foam::cos(rollDisp.x()) * (leftBot.z() - rotationCenter.z()) )
				      + rotationCenter.z() + heaveDisp.z() ;	
	
		vector newTopR(0,0,0);
		newTopR.y() = ( Foam::cos(rollDisp.x()) * (rightTop.y() - rotationCenter.y()) 
			          + Foam::sin(rollDisp.x()) * (rightTop.z() - rotationCenter.z()) )
				      + rotationCenter.y() + swayDisp.y();
		newTopR.z() = (- Foam::sin(rollDisp.x()) * (rightTop.y() - rotationCenter.y()) 
			      	  + Foam::cos(rollDisp.x()) * (rightTop.z() - rotationCenter.z()) )
				      + rotationCenter.z() + heaveDisp.z() ;

		vector newBotR(0,0,0);
		newBotR.y() = ( Foam::cos(rollDisp.x()) * (rightBot.y() - rotationCenter.y()) 
			      	  + Foam::sin(rollDisp.x()) * (rightBot.z() - rotationCenter.z()) )
				      + rotationCenter.y() + swayDisp.y();
		newBotR.z() = (- Foam::sin(rollDisp.x()) * (rightBot.y() - rotationCenter.y()) 
			      	  + Foam::cos(rollDisp.x()) * (rightBot.z() - rotationCenter.z()) )
			      	  + rotationCenter.z() + heaveDisp.z() ;
		
		scalar tFSLeft = -newTopL.z()/(newBotL.z() - newTopL.z());
		scalar tFSRight = -newTopR.z()/(newBotR.z() - newTopR.z());
		/* correcting the motions to include free surface cut */
		for (label i=0; i<bodyPointsDisp.size(); i++) {
			
			scalar flag = pntTab(i);
			
			if ( ( flag >= 1.0 ) && ( flag <= 2.0) ){
				scalar t = flag - 1.0;
				
				bodyPointsDisp[i].y() = bodyPointsDisp[i].y() +
						(1 - t) * tFSLeft * (newBotL.y() - newTopL.y());

				bodyPointsDisp[i].z() = bodyPointsDisp[i].z() +
						(1 - t) * tFSLeft * (newBotL.z() - newTopL.z());
				
				if (t == 0.0) {
					bodyPointsDisp[i].z() = 0.0;
				}


			}
			else if ( ( flag >= 3.0 ) && ( flag <= 4.0) ){
				scalar t = flag - 3.0;
				bodyPointsDisp[i].y() = bodyPointsDisp[i].y() +
						(1 - t) * tFSRight * (newBotR.y() - newTopR.y());

				bodyPointsDisp[i].z() = bodyPointsDisp[i].z() +
						(1 - t) * tFSRight * (newBotR.z() - newTopR.z());
				
				if (t == 0.0) {
					bodyPointsDisp[i].z() = 0.0;
				}

			}
		}

		operator==(bodyPointsDisp);
//}}} end code

    this->fixedValuePointPatchField<vector>::updateCoeffs();
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

} // End namespace Foam

// ************************************************************************* //

