% clear all; close all; clc
% filenames=['RC0_1.bin';'RC0_2.bin';'RC0_3.bin';'RC0_4.bin';'BB1_1.bin';...
%     'BB1_2.bin';'BB1_3.bin';'BB1_4.bin';'BB2_1.bin';'BB2_2.bin';...
%     'BB2_3.bin';'BB2_4.bin';'BB3_1.bin';'BB3_2.bin';'BB3_3.bin';'BB3_4.bin'];
filenames=['BB1_1.bin';];
m=1;
for mainloop=1:size(filenames,1)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Main Post-Processing Script                                            %
%  Created by : Muhammad Mukhlas, NTNU, 2017                              %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Load File                                                              %
% IMPORTANT NOTES:                                                        % 
% *Coordinate system : Inertia earth-fixed reference frame @ MWL          % 
% *Seakeeping coordinate system (y,z) axis; y right-positive              %
%  z above-positive                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Open the file and data declaration                                     %
filename=filenames(mainloop,:);                                           %
open_results=['C:\Users\mkhls\OneDrive - NTNU\Master Thesis\Model Tests\Forced roll\Raw Data\Forced roll Apr 2017\' filename];%
[a1,a2]=catman_read_5r8(open_results);                                    %
t = a2(1).data';                                                          %
accC = a2(2).data';                       %right                          %
accB = a2(3).data';                       %left                           %
Fz_exc = a2(4).data';                     %right                          %
Fy_A = a2(5).data'; Fz_A = a2(6).data';   %left-front                     %
Fy_B = a2(7).data'; Fz_B = a2(8).data';   %left-back                      %
Fy_C = a2(9).data'; Fz_C = a2(10).data';  %right-back                     %
Fy_D = a2(11).data'; Fz_D = a2(12).data'; %right-front                    %
if filename(5)=='1' | filename(5)=='2'                                    %
WP1 = a2(13).data'; WP2 = a2(14).data';   %1:left-front 2:left-back       %
WP3 = a2(15).data'; WP4 = a2(16).data';   %3:right-front 4:right-back     %
else                                                                      %
end                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Filter the signal                                                      %
samp_rate = 600;                          %[Hz]                           %
dt = 1/samp_rate;                         %[s]                            %
while(1)                                                                  %
prompt = {'Low Frequency (Hz):','High Frequency (Hz):'};                  %
dlg_title = 'Band-Pass Filtering';                                        %
defaultans = {'0.3','5'};                                                 %
answer = inputdlg(prompt,dlg_title,[1 40],defaultans);                    %
f_low = str2num(answer{1}); f_high=str2num(answer{2});                    %
accC_filt = bpass(accC,dt,f_low,f_high,1);                                %
accB_filt = bpass(accB,dt,f_low,f_high,1);                                %
Fz_exc_filt = bpass(Fz_exc,dt,f_low,f_high,1);                            %
Fy_A_filt = bpass(Fy_A,dt,f_low,f_high,0); Fz_A_filt = bpass...           %
    (Fz_A,dt,f_low,f_high,0);                                             %
Fy_B_filt = bpass(Fy_B,dt,f_low,f_high,0); Fz_B_filt = bpass...           %
    (Fz_B,dt,f_low,f_high,0);                                             %
Fy_C_filt = bpass(Fy_C,dt,f_low,f_high,0); Fz_C_filt = bpass...           %
    (Fz_C,dt,f_low,f_high,0);                                             %
Fy_D_filt = bpass(Fy_D,dt,f_low,f_high,0); Fz_D_filt = bpass...           %
    (Fz_D,dt,f_low,f_high,0);                                             %
if filename(5)=='1' | filename(5)=='2'                                    %
    WP1_filt = bpass(WP1,dt,f_low,f_high,0); WP2_filt = bpass....         %
    (WP2,dt,f_low,f_high,0);                                              %
    WP3_filt = bpass(WP3,dt,f_low,f_high,0); WP4_filt = bpass...          %
    (WP4,dt,f_low,f_high,0);                                              %
else                                                                      %
end                                                                       %
promptMessage = sprintf...                                                %
  ('Do you want to Continue processing,\nor Cancel to abort processing?');%
button = questdlg...                                                      %
  (promptMessage, 'Filter the signal', 'Continue', 'Cancel', 'Continue'); %
if strcmpi(button, 'Cancel')                                              %
	return; % Or break or continue                                        %
end                                                                       %
close all                                                                 %
break;                                                                    %
end                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
figure;
plot(t,accC,'r');hold on;plot(t,accC_filt,'g');
title('Filtered Time Series'); xlabel('time(s)'); ylabel('Acceleration C (m/s^2)');
legend('Unfiltered','Filtered');
pause(35.0);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Cut the data (If something messy)                                      %    
while(1)                                                                  %
promptMessage = sprintf('Do you think the time series need to be cut?');  %
button = questdlg(promptMessage, 'Cut the signal', 'Cut', 'No', 'Cut');   %
close all                                                                 %
if strcmpi(button, 'Cut')                                                 %
    prompt = {'Time start (s):','Time end(s):'};                          %
    dlg_title = 'Cut Time Series';                                        %
    defaultans = {'4','10000'};                                           %
    answer = inputdlg(prompt,dlg_title,[1 40],defaultans);                %
    t_start = str2num(answer{1});    % t_start = 0;                       %                                 %
    t_end   = str2num(answer{2});    % t_end   = t(end);                  %                                %
    [accC_filt,time] = mukCut(t,accC_filt,t_start,t_end);                 %
    accB_filt        = mukCut(t,accB_filt,t_start,t_end);                 %
    Fz_exc_filt      = mukCut(t,Fz_exc_filt,t_start,t_end);               %
    Fy_A_filt        = mukCut(t,Fy_A_filt,t_start,t_end);                 %
    Fz_A_filt        = mukCut(t,Fz_A_filt,t_start,t_end);                 %
    Fy_B_filt        = mukCut(t,Fy_B_filt,t_start,t_end);                 %
    Fz_B_filt        = mukCut(t,Fz_B_filt,t_start,t_end);                 %
    Fy_C_filt        = mukCut(t,Fy_C_filt,t_start,t_end);                 %
    Fz_C_filt        = mukCut(t,Fz_C_filt,t_start,t_end);                 %
    Fy_D_filt        = mukCut(t,Fy_D_filt,t_start,t_end);                 %
    Fz_D_filt        = mukCut(t,Fz_D_filt,t_start,t_end);                 %
    if filename(5)=='1' | filename(5)=='2'                                %
    WP1_filt         = mukCut(t,WP1_filt,t_start,t_end);                  %
    WP2_filt         = mukCut(t,WP2_filt,t_start,t_end);                  %
    WP3_filt         = mukCut(t,WP3_filt,t_start,t_end);                  %
    WP4_filt         = mukCut(t,WP4_filt,t_start,t_end);                  %
    else                                                                  %                                            %
    end                                                                   %
    break;                                                                %
elseif strcmpi(button, 'No')                                              %
    time=t;                                                               %
    break; % Or break or continue                                         %
end                                                                       %
break                                                                     %
end                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Find Roll Acceleration, Velocity and Amplitude                         %
l_acc=0.240; %distance between vertical line to the accelerometer   %
while (1)                                                                 %
freq=[0:0.05:4*f_low];                                                    %
if filename(5)=='1';plott=730;elseif filename(5)=='3';plott=730;...       %
else;plott=650;end                                                        %
for i=1:length(freq)                                                      %
dummy=FindAngVel(time,accC_filt,accB_filt,l_acc,dt,freq(i));              %
plot(time(find(time<=plott)),dummy(find(time<=plott)));                   %
title (['High-pass filter:' num2str(freq(i)) ' Hz'])                      %
drawnow                                                                   %
end                                                                       %
close all                                                                 %
prompt = {'High-pass filter (Hz):'};                                      %
dlg_title = 'Select the high-pass filter frequency';                      %
defaultans = {'0.3'};                                                     %
answer = inputdlg(prompt,dlg_title,[1 40],defaultans);                    %
[eta4,eta4dot,eta4dotdot]=FindAngVel(time,accC_filt,accB_filt,l_acc,...   %
    dt,str2num(answer{1}));                                               %
figure;                                                                   %
plot(time,eta4);                                                          %
xlabel('Time (s)'); ylabel('Rotational Angle (^o)');                      %
pause(20.0);                                                              %
close all;                                                                %
promptMessage = sprintf('Are you satisfied?');                            %
button = questdlg(promptMessage, 'Rotational Angle', 'Yes', 'No', 'Yes'); %
if strcmpi(button, 'No')                                                  %
	return; % Or break or continue                                        %
end                                                                       %
break;                                                                    %
end                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Steady-state extractor                                                 %
while(1)                                                                  %
accC_ss=ststate(accC_filt,accC_filt,dt,f_low,filename);                   %
accB_ss=ststate(accB_filt,accC_filt,dt,f_low,filename);                   %
eta4_ss=ststate(eta4,accC_filt,dt,f_low,filename);                        %
eta4dot_ss=ststate(eta4dot,accC_filt,dt,f_low,filename);                  %
eta4dotdot_ss=ststate(eta4dotdot,accC_filt,dt,f_low,filename);            %
Fz_exc_ss=ststate(Fz_exc_filt,accC_filt,dt,f_low,filename);               %
Fy_A_ss=ststate(Fy_A_filt,accC_filt,dt,f_low,filename);                   %
Fz_A_ss=ststate(Fz_A_filt,accC_filt,dt,f_low,filename);                   %
Fy_B_ss=ststate(Fy_B_filt,accC_filt,dt,f_low,filename);                   %
Fz_B_ss=ststate(Fz_B_filt,accC_filt,dt,f_low,filename);                   %
Fy_C_ss=ststate(Fy_C_filt,accC_filt,dt,f_low,filename);                   %
Fz_C_ss=ststate(Fz_C_filt,accC_filt,dt,f_low,filename);                   %
Fy_D_ss=ststate(Fy_D_filt,accC_filt,dt,f_low,filename);                   %
Fz_D_ss=ststate(Fz_D_filt,accC_filt,dt,f_low,filename);                   %
if filename(5)=='1' | filename(5)=='2'                                    %
  WP1_ss=ststate(WP1_filt,accC_filt,dt,f_low,filename);                   %
  WP2_ss=ststate(WP2_filt,accC_filt,dt,f_low,filename);                   %
  WP3_ss=ststate(WP3_filt,accC_filt,dt,f_low,filename);                   %
  WP4_ss=ststate(WP4_filt,accC_filt,dt,f_low,filename);                   %
else                                                                      %
end                                                                       %
% Check the time series                                                   %
figure;                                                                   %
plot(time,accC_filt);                                                     %
hold on;                                                                  %
plot(time,accC_ss);                                                       %
title('Time Series Check');                                               %
xlabel('Time (seconds)');                                                 %
ylabel('Acceleration C (m/s^2)');                                         %
legend('Simulated Time Series','Steady-State Time Series');               %
pause(120.0);                                                             %
close all;                                                                %
promptMessage = sprintf('Are you satisfied?');                            %
button = questdlg(promptMessage, 'Steady State', 'Yes', 'No', 'Yes');     %
if strcmpi(button, 'No')                                                  %
	return; % Or break or continue                                        %
end                                                                       %
break;                                                                    %
end                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Organizing the time-series
if filename(5)=='1';num_period=4;elseif filename(5)=='3';num_period=4;...
else;num_period=3;end
if filename(5)=='1';cond='Water';elseif filename(5)=='2';cond='Water';...
else;cond='Air';end
num_amp=13; num_osc=39; %steady-state=40 osc, sacrificed 1 osc.
zuc=mukZuC(time,eta4_ss);

for i=1:(num_amp*num_period)
    x=eta4_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    t=time(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    [f,FFT] = mukFFT2(t,x);
    peak=findpeaks(FFT,'MinPeakHeight',10000); 
    timeseries_exp(m).object=filename(1:3);
    timeseries_exp(m).cond=cond;
    timeseries_exp(m).amplitude=(mean(findpeaks(x))+mean(findpeaks(-x)))/2;
    timeseries_exp(m).period=round(1/(f(find(FFT==peak))),2);
    timeseries_exp(m).time=t-t(1);
    timeseries_exp(m).eta4=x;
    timeseries_exp(m).eta4dot=eta4dot_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).eta4dotdot=eta4dotdot_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fz_exc=Fz_exc_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).M_exc=Fz_exc_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)))...
                             .*cosd(x).*(0.329-(0.1544*sind(x)));     %0.329 m : midship to sensor attachment, 0.1544 m : Freeboard
    timeseries_exp(m).Fy_A=Fy_A_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fz_A=Fz_A_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fy_B=Fy_B_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fz_B=Fz_B_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fy_C=Fy_C_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fz_C=Fz_C_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fy_D=Fy_D_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).Fz_D=Fz_D_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    if filename(5)=='1' | filename(5)=='2'  
    timeseries_exp(m).WP1=WP1_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).WP2=WP2_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).WP3=WP3_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    timeseries_exp(m).WP4=WP4_ss(zuc(((i-1)*(num_osc+1))+1):zuc(i*(num_osc+1)));
    else
    end 
    m=m+1;
end
end
save(filename(1:3),'timeseries_exp');