function BBFCurve(scen,xaxis,yaxis,multi,database_exp,database_cfd);
close all;
scen=scen;
xaxis=xaxis;
yaxis=yaxis;
multi=multi;

% Field Indices
strvar_exp=fieldnames(database_exp);
strvar_cfd=fieldnames(database_cfd);

scen_exp_ind=find(strcmp(strvar_exp,scen)); 
xaxis_exp_ind=find(strcmp(strvar_exp,xaxis)); 
yaxis_exp_ind=find(strcmp(strvar_exp,yaxis)); 
multi_exp_ind=find(strcmp(strvar_exp,multi)); 

scen_cfd_ind=find(strcmp(strvar_cfd,scen)); 
xaxis_cfd_ind=find(strcmp(strvar_cfd,xaxis)); 
yaxis_cfd_ind=find(strcmp(strvar_cfd,yaxis));
multi_cfd_ind=find(strcmp(strvar_cfd,multi)); 

scen_exp_var=cell2mat({database_exp.(strvar_exp{scen_exp_ind})}');
xaxis_exp_var=cell2mat({database_exp.(strvar_exp{xaxis_exp_ind})}');
yaxis_exp_var=cell2mat({database_exp.(strvar_exp{yaxis_exp_ind})}');
multi_exp_var=cell2mat({database_exp.(strvar_exp{multi_exp_ind})}');

scen_cfd_var=cell2mat({database_cfd.(strvar_cfd{scen_cfd_ind})}');
xaxis_cfd_var=cell2mat({database_cfd.(strvar_cfd{xaxis_cfd_ind})}');
yaxis_cfd_var=cell2mat({database_cfd.(strvar_cfd{yaxis_cfd_ind})}');
multi_cfd_var=cell2mat({database_cfd.(strvar_cfd{multi_cfd_ind})}');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(scen,'object')==1
    scen_inp=unique(scen_exp_var,'rows');
else
    scen_inp=unique(scen_exp_var);
end

xaxis_inp=unique(cell2mat({database_exp.(strvar_exp{xaxis_exp_ind})}'));
xaxis_inp2=unique(cell2mat({database_cfd.(strvar_cfd{xaxis_cfd_ind})}'));

if  strcmp(multi,'object')==1
    multi_inp=intersect(unique(multi_exp_var,'rows'),unique(multi_cfd_var,'rows'),'rows');
else
    multi_inp=intersect(unique((multi_exp_var)),unique((multi_cfd_var)));
end


for k=1:length(multi_inp)
j=1;
figure;
axis([0 inf 0 inf]);
for i=1:length(scen_inp);
%% Definition of scen index
%%%% Experiment
if isa(scen_inp(i),'double')==1
    scen_exp_ind2=find(scen_exp_var==scen_inp(i));
else
    scen_exp_ind2=strmatch(scen_inp(i,:), scen_exp_var, 'exact');
end

%%%% CFD
if  isa(scen_inp(i),'double')==1
    scen_cfd_ind2=find(scen_cfd_var==scen_inp(i));
else
    scen_cfd_ind2=strmatch(scen_inp(i,:), scen_cfd_var, 'exact');
end

%% Definition of multi index  
%%%% Experiment
if  isa(multi_inp(k,:),'double')==1
    multi_exp_ind2=find(multi_exp_var==multi_inp(k,:));
else
    multi_exp_ind2=strmatch(multi_inp(k,:), multi_exp_var, 'exact');
end

%%%% CFD
if  isa(multi_inp(k,:),'double')==1
    multi_cfd_ind2=find(multi_cfd_var==multi_inp(k,:));
else
    multi_cfd_ind2=strmatch(multi_inp(k,:), multi_cfd_var, 'exact');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plotStyle1 = {'-ks','-kd','-ko','-k*','-k^','-k+','-kx','-k>','-kp','-kv','-kh','-k<','-k.'};
plotStyle2 = {':ks',':kd',':ko',':k*',':k^',':k+',':kx',':k>',':kp',':kv',':kh',':k<',':k.'};
inter1=intersect(scen_exp_ind2,multi_exp_ind2)';
inter2=intersect(scen_cfd_ind2,multi_cfd_ind2)';
plot([xaxis_exp_var(inter1)],[yaxis_exp_var(inter1)],plotStyle2{j},'MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([xaxis_cfd_var(inter2)],[yaxis_cfd_var(inter2)],plotStyle1{j},'MarkerFaceColor','k');
if length(inter1)>0
    if strcmp(scen,'period_nondim')==1
        legendInfo{(2*j)-1} = ['Exp, ' '$T \sqrt{2g/B} = $' num2str(scen_inp(i),'%.2f')];
        legendInfo{2*j} = ['PVC2D-Roll ' '$T \sqrt{2g/B} = $' num2str(scen_inp(i),'%.2f')];       
    else
        legendInfo{(2*j)-1} = ['Exp, ' scen_inp(i,:)];
        legendInfo{2*j} = ['PVC2D-Roll, ' scen_inp(i,:)];
    end
else
end
if length(inter1)>0
    j=j+1;
else
    j=j;
end
end
legend(legendInfo)
set(legend,'interpreter','latex');
set(legend,'Location','northwest');
set(legend,'fontsize',12);

if strcmp(xaxis,'amplitude')==1
   hl=xlabel('$\theta (deg)$','FontSize', 15);
   set(hl, 'Interpreter', 'latex');
else
   xlabel('KC','FontSize', 15);
end

if strcmp(yaxis(1:3),'a33')==1
    hl=ylabel('$a_{33} / \rho \pi a^2$','FontSize', 15);
    set(hl, 'Interpreter', 'latex');
elseif strcmp(yaxis(1:3),'b33')==1
    hl=ylabel('$b_{33} \sqrt{a/2g} / \rho A$','FontSize', 15);
    set(hl, 'Interpreter', 'latex');
else
    hl=ylabel('$M_b / \rho A L_{BB}^2 (2g/B)$','FontSize', 15);
    set(hl, 'Interpreter', 'latex');
end
   
if strcmp(multi,'object')==1
    hl=title(['Case ' multi_inp(k,:)],'FontSize', 15);
    set(hl, 'Interpreter', 'latex');
else
    hl=title(['$CaseT \sqrt{2g/B} = $' num2str(multi_inp(k))],'FontSize', 15);
    set(hl, 'Interpreter', 'latex');
end
grid on
% axis auto
pbaspect([1 1 1])
axis auto;
hold off
end
end
