function [SS_exp,SS_cfd]=ExtSS(database_exp,database_cfd,peak_dl,peak_ul);
SS_exp=struct(); SS_cfd=struct();
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Extract the steady state part of the experiment data
waterexp = [1:91,183:273,365:455,547:637,729:819];
chnames = { 
'object'
'cond'
'amplitude'
'period'
'time'
'eta4'
'eta4dot'
'eta4dotdot'
'Fz_exc'
'M_exc'
'Fy_A'
'Fz_A'
'Fy_B'
'Fz_B'
'Fy_C'
'Fz_C'
'Fy_D'
'Fz_D'
'WP1'
'WP2'
'WP3'
'WP4'
}; 
exp=1;
for i=waterexp
    srcdata = database_exp(i);
    [a,b]=findpeaks(database_exp(i).eta4); limit_a=b(peak_dl); limit_b=b(peak_ul);
    for chi = 1:length(chnames)
        chname = chnames{chi};
        chname2 = [chnames{chi} '_before'];
        arr=getfield(srcdata,chname);
        if isa(database_exp(i).(chname),'char')==1
            SS_exp(exp).(chname)= arr;
        elseif length(arr)==1
            SS_exp(exp).(chname)= arr;
        else
            SS_exp(exp).(chname2)= arr;
            SS_exp(exp).(chname)= arr(limit_a:limit_b);
        end
    end
    exp=exp+1;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Extract the steady state part of the CFD data
chnames = { 
    'object'
    'amplitude'
    'period'
    't_imposed'
    'eta4_imposed'
    'eta4dot_imposed'
    'eta4dotdot_imposed'
    't_postproc'
%     'M_Total'
    'M_Totaldyn'
    'Fx_BKLdyn'
    'Fy_BKLdyn'
    'Fz_BKLdyn'
    'Fx_BKRdyn'
    'Fy_BKRdyn'
    'Fz_BKRdyn'
%     'pgh_left_x125'
%     'pgh_left_x425'
%     'pgh_left_x650'
%     'pgh_right_x125'
%     'pgh_right_x425'
%     'pgh_right_x650'
};

for i=1:size(database_cfd,2)
%     database_cfd(i).pgh_left_x125=database_cfd(i).pgh_left.x125;
%     database_cfd(i).pgh_left_x425=database_cfd(i).pgh_left.x425;
%     database_cfd(i).pgh_left_x650=database_cfd(i).pgh_left.x650;
%     database_cfd(i).pgh_right_x125=database_cfd(i).pgh_right.x125;
%     database_cfd(i).pgh_right_x425=database_cfd(i).pgh_right.x425;
%     database_cfd(i).pgh_right_x650=database_cfd(i).pgh_right.x650;    
%     
    %%% n-th oscillation
    if database_cfd(i).period==1
        cut_start=10; cut_end=15;
    elseif database_cfd(i).period==1.15
        cut_start=11.5; cut_end=17.25;
    elseif database_cfd(i).period==1.35
        cut_start=13.5; cut_end=20.25;
    elseif database_cfd(i).period==1.5
        cut_start=15; cut_end=22.5;
    elseif database_cfd(i).period==1.7
        cut_start=17; cut_end=25.5;
    elseif database_cfd(i).period==1.85
        cut_start=18.5; cut_end=25.90;
    else
        cut_start=18; cut_end=24;
    end
    
    up=find(database_cfd(i).t_imposed >= cut_start);
    down=find(database_cfd(i).t_imposed <= cut_end);
    cut_index=intersect(up,down);
    
    srcdata = database_cfd(i);
    
    for chi = 1:length(chnames)
        chname = chnames{chi};
        chname2 = [chnames{chi} '_before'];
        arr = getfield(srcdata,chname);
        if isa(arr,'char')==1
            SS_cfd(i).(chname)=arr;
        elseif length(arr)==1
            SS_cfd(i).(chname)=arr;
        else
            SS_cfd(i).(chname2)=arr;
            SS_cfd(i).(chname)=arr(cut_index);
        end
    end
end