% function [database_exp,database_cfd]=HydCoeff(database_exp,database_cfd);
function [database_exp,database_cfd]=HydCoeff(database_exp,database_cfd,SS_exp,SS_cfd);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% EXPERIMENT HYDRODYNAMIC COEFF EXTRACTION
load(['M:\thesismatlab\Main Postproc\variables.mat']);
wateronly=[1:91,183:273,365:455,547:637,729:819];
wcheck=1;
for i=1:size(database_exp,2)
    database_exp(i).period_nondim=database_exp(i).period*sqrt(2*g/B);
    %%% Definition of cross section area, I44 and C44
    if database_exp(i).object=='RC0';
        A=((B*(D-RC))+(RC*(B-(2*RC)))+(0.5*pi*RC^2));
        I44=0.92/t1; %[kgm^2]
%         I44=0.0006559;
        GM=0.12874;
        C44=rho*g*A*GM;
        C44_air=0.01815;
%         C44=0.05;
    elseif database_exp(i).object=='RC_';
        A=((B*(D-RC))+(RC*(B-(2*RC)))+(0.5*pi*RC^2));
        I44=0.92/t1; %[kgm^2]
%         I44=0.0006559;
        GM=0.12874;
        C44=rho*g*A*GM;
        C44_air=0.01815;
%         C44=0.05;
    elseif database_exp(i).object=='BB1';
        A=((B*D)+(t*BB1));
        I44=1.06/t1; %[kgm^2]
%         I44=0.0007424;
        GM=0.12248;
        C44=rho*g*A*GM;
        C44_air=0.01974;
%         C44=0.05;
    elseif database_exp(i).object=='BB2';
        A=((B*D)+(t*BB2));
        I44=1.14/t1; %[kgm^2]
%         I44=0.0007951;
        GM=0.12049;
        C44=rho*g*A*GM;
        C44_air=0.02019;
%         C44=0.05;
    elseif database_exp(i).object=='BB3';
        A=((B*D)+(t*BB3));
        I44=1.26/t1; %[kgm^2]
%         I44=0.0008621;
        GM=0.1165;
        C44=rho*g*A*GM;
        C44_air=0.02126;
%         C44=0.05;
    else
        A=((B*D)+(t*BB3));
        I44=1.26/t1; %[kgm^2]
%         I44=0.0008621;
        GM=0.1165;
        C44=rho*g*A*GM;
        C44_air=0.02126;
%         C44=0.05;
    end
    
    if length(find(wateronly==i))>0
    database_exp(i).damping=trapz(SS_exp(wcheck).time,...
    (SS_exp(wcheck).M_exc/t1).*SS_exp(wcheck).eta4dot*(pi/180))./...
    trapz(SS_exp(wcheck).time,(SS_exp(wcheck).eta4dot.*...
    SS_exp(wcheck).eta4dot*(pi/180)*(pi/180)));   
    
    database_exp(i).damping_nondim_s=database_exp(i).damping.*(sqrt(B/(2*g))/(rho*A*B^2)); 

    database_exp(i).addedmass=((trapz(SS_exp(wcheck).time,...
    (SS_exp(wcheck).M_exc/t1).*SS_exp(wcheck).eta4dotdot*(pi/180))-...
    trapz(SS_exp(wcheck).time,C44.*SS_exp(wcheck).eta4.*SS_exp(wcheck).eta4dotdot*(pi/180)*(pi/180))-...
    trapz(SS_exp(wcheck).time,I44.*SS_exp(wcheck).eta4dotdot.*SS_exp(wcheck).eta4dotdot*(pi/180)*(pi/180)))./...
    trapz(SS_exp(wcheck).time,SS_exp(wcheck).eta4dotdot.*SS_exp(wcheck).eta4dotdot*(pi/180)*(pi/180)));  
    
    database_exp(i).addedmass_nondim_s=database_exp(i).addedmass./(rho*A*B^2);  
    database_exp(i).addedmass_nondim=database_exp(i).addedmass_nondim_s;

    %%%% Subtract with the rounded corner (coloumb, friction ,etc.)
%     consistent_damping=0.01011; %This is uncertain, it could be also friction / unwated damping from the system which is consistent
    consistent_damping=0.0;
    if database_exp(i).object=='BB1' & length(database_exp(i).cond)==5
        database_exp(i).damping_nondim=((database_exp(i).damping-database_exp(i-182).damping).*(sqrt(B/(2*g))/(rho*A*B^2)))+consistent_damping; 
    elseif database_exp(i).object=='BB2' & length(database_exp(i).cond)==5
        database_exp(i).damping_nondim=((database_exp(i).damping-database_exp(i-364).damping).*(sqrt(B/(2*g))/(rho*A*B^2)))+consistent_damping; 
    elseif database_exp(i).object=='BB3' & length(database_exp(i).cond)==5
        database_exp(i).damping_nondim=((database_exp(i).damping-database_exp(i-546).damping).*(sqrt(B/(2*g))/(rho*A*B^2)))+consistent_damping;
    elseif database_exp(i).object=='BX3' & length(database_exp(i).cond)==5
        database_exp(i).damping_nondim=((database_exp(i).damping-database_exp(i-728).damping).*(sqrt(B/(2*g))/(rho*A*B^2)))+consistent_damping;
    else
        database_exp(i).damping_nondim=database_exp(i).damping_nondim_s;
    end
    
%     consistent_addedmass=0.0;
%     if database_exp(i).object=='BB1' & length(database_exp(i).cond)==5
%         database_exp(i).addedmass_nondim=((database_exp(i).addedmass-database_exp(i-182).addedmass)./(rho*A*B^2))+consistent_addedmass;; 
%     elseif database_exp(i).object=='BB2' & length(database_exp(i).cond)==5
%         database_exp(i).addedmass_nondim=((database_exp(i).addedmass-database_exp(i-364).addedmass)./(rho*A*B^2))+consistent_addedmass;
%     elseif database_exp(i).object=='BB3' & length(database_exp(i).cond)==5
%         database_exp(i).addedmass_nondim=((database_exp(i).addedmass-database_exp(i-546).addedmass)./(rho*A*B^2))+consistent_addedmass;
%     elseif database_exp(i).object=='BX3' & length(database_exp(i).cond)==5
%         database_exp(i).addedmass_nondim=((database_exp(i).addedmass-database_exp(i-728).addedmass)./(rho*A*B^2))+consistent_addedmass;
%     else
%         database_exp(i).addedmass_nondim=database_exp(i).addedmass_nondim_s;
%     end
   
    wcheck=wcheck+1;
    else
        database_exp(i).damping=trapz(database_exp(i).time,...
           (database_exp(i).M_exc/t1).*database_exp(i).eta4dot*(pi/180))./...
           trapz(database_exp(i).time,(database_exp(i).eta4dot.*...
           database_exp(i).eta4dot*(pi/180)*(pi/180)));   
        database_exp(i).damping_nondim_s=database_exp(i).damping.*(sqrt(B/(2*g))/(rho*A*B^2)); 
        database_exp(i).damping_nondim=database_exp(i).damping_nondim_s;
       
        database_exp(i).addedmass=trapz(database_exp(i).time,(database_exp(i).M_exc/t1).*database_exp(i).eta4dotdot*(pi/180))*(2/(39*database_exp(i).period)); 
        database_exp(i).addedmass_nondim_s=database_exp(i).addedmass;
        database_exp(i).addedmass_nondim=database_exp(i).addedmass_nondim_s;
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CFD HYDRODYNAMIC COEFF EXTRACTION
for i=1:size(database_cfd,2)
    database_cfd(i).period_nondim=database_cfd(i).period*sqrt(2*g/B);
    if database_cfd(i).object=='BB1';
        A=((B*D)+(t*BB1));
    elseif database_cfd(i).object=='BB2';
        A=((B*D)+(t*BB2));
    elseif database_cfd(i).object=='BB3';
        A=((B*D)+(t*BB3));
    else
        A=((B*(D-RC))+(RC*(B-(2*RC)))+(0.5*pi*RC^2));
    end
    
    damping=(trapz(SS_cfd(i).t_postproc,...
    (-SS_cfd(i).M_Totaldyn/t2).*SS_cfd(i).eta4dot_imposed*(pi/180))./...
    trapz(SS_cfd(i).t_postproc,(SS_cfd(i).eta4dot_imposed.*...
    SS_cfd(i).eta4dot_imposed*(pi/180)*(pi/180))));
    database_cfd(i).damping_nondim=damping.*(sqrt(B/(2*g))/(rho*A*B^2));

    addedmass=(trapz(SS_cfd(i).t_postproc,...
    (-SS_cfd(i).M_Totaldyn/t2).*SS_cfd(i).eta4dotdot_imposed*(pi/180))./...
    trapz(SS_cfd(i).t_postproc,(SS_cfd(i).eta4dotdot_imposed.*...
    SS_cfd(i).eta4dotdot_imposed*(pi/180)*(pi/180))));
    database_cfd(i).addedmass_nondim=addedmass./(rho*A*B^2);   
    
%     database_cfd(i).restoring= (trapz(SS_cfd(i).t_postproc,...
%     (-SS_cfd(i).M_Total/t2).*SS_cfd(i).eta4dotdot_imposed*(pi/180))-...
%     trapz(SS_cfd(i).t_postproc,addedmass.*SS_cfd(i).eta4dotdot_imposed.*...
%     SS_cfd(i).eta4dotdot_imposed*(pi/180)*(pi/180)))./...
%     trapz(SS_cfd(i).t_postproc,SS_cfd(i).eta4_imposed.*...
%     SS_cfd(i).eta4dotdot_imposed*(pi/180)*(pi/180));
    
%     database_cfd(i).damping_nondim=(trapz(SS_cfd(i).t_postproc,...
%     (-SS_cfd(i).M_Totaldyn/t2).*SS_cfd(i).eta4dot_imposed*(pi/180))./...
%     trapz(SS_cfd(i).t_postproc,(SS_cfd(i).eta4dot_imposed.*...
%     SS_cfd(i).eta4dot_imposed*(pi/180)*(pi/180)))).*(sqrt(B/(2*g))/(rho*A*B^2));
% 
%     database_cfd(i).addedmass_nondim=(trapz(SS_cfd(i).t_postproc,...
%     (-SS_cfd(i).M_Totaldyn/t2).*SS_cfd(i).eta4dotdot_imposed*(pi/180))./...
%     trapz(SS_cfd(i).t_postproc,(SS_cfd(i).eta4dotdot_imposed.*...
%     SS_cfd(i).eta4dotdot_imposed*(pi/180)*(pi/180))))./(rho*A*B^2);
end
index1=find(ismember({database_cfd.object}, 'RC0'));
% for i=1:266
%     index2=find([database_cfd.period]==database_cfd(i).period);
%     index3=find([database_cfd.amplitude]==database_cfd(i).amplitude);
%     index=intersect(intersect(index1,index2),index3);
%     database_cfd(i).damping_nondim=database_cfd(i).damping_nondim-database_cfd(index).damping_nondim;
%     database_cfd(i).addedmass_nondim=database_cfd(i).addedmass_nondim-database_cfd(index).addedmass_nondim;
% end
end