function HydCurve(scen,xaxis,yaxis,multi,database_exp,database_cfd);
close all;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Plot
% scen='period';
% xaxis='amplitude';
% yaxis='addedmass_nondim';
% multi='object';
% cond='cond';
scen=scen;
xaxis=xaxis;
yaxis=yaxis;
multi=multi;
cond='cond';
cond_inp='Water';

if strcmp(yaxis,'addedmass_nondim')==1 & strcmp(xaxis,'period_nondim')==1
    [Om_pot_BT2,A44_pot_BT2] = importpota44BT2('M:\potentialflowcalc\BT2\BT2_A44.txt');
    [Om_pot_BT4,A44_pot_BT4] = importpota44BT4('M:\potentialflowcalc\BT4b\BT4b_A44.txt');
    figure;
    plot([database_exp(1:4).period_nondim, database_exp(53:55).period_nondim], [database_exp(1:4).addedmass_nondim, database_exp(53:55).addedmass_nondim],'ko-'); hold on;
    plot([database_exp(5:8).period_nondim, database_exp(56:58).period_nondim], [database_exp(5:8).addedmass_nondim, database_exp(56:58).addedmass_nondim],'ks-'); hold on;
    plot([database_exp(9:12).period_nondim, database_exp(59:61).period_nondim], [database_exp(9:12).addedmass_nondim, database_exp(59:61).addedmass_nondim],'kd-'); hold on;
    plot([database_exp(13:16).period_nondim, database_exp(62:64).period_nondim], [database_exp(13:16).addedmass_nondim, database_exp(62:64).addedmass_nondim],'k^-'); hold on;
    plot([database_exp(49:52).period_nondim, database_exp(89:91).period_nondim], [database_exp(49:52).addedmass_nondim, database_exp(89:91).addedmass_nondim],'kh-'); hold on;
    plot((2*pi./Om_pot_BT2).*sqrt(2*9.81/2),A44_pot_BT2./(1000*2*2^2),'r');
    plot((2*pi./Om_pot_BT4).*sqrt(2*9.81/2),A44_pot_BT4./(1000*4*4^2),'b');
    legend('Experiment \theta=2^o','Experiment \theta=3^o','Experiment \theta=4^o','Experiment \theta=5^o','Experiment \theta=14^o','Potential calc B/T=2','Potential calc B/T=4');
    axis ([6 13 0 0.1]);
    grid on
    hl1=xlabel('$T \sqrt{2g/B}$');
    hl2=ylabel('$a_{44} / \rho A B^2$');
    set(hl1, 'Interpreter', 'latex');
    set(hl2, 'Interpreter', 'latex');
    hold off;
end

% Field Indices
strvar_exp=fieldnames(database_exp);
strvar_cfd=fieldnames(database_cfd);

scen_exp_ind=find(strcmp(strvar_exp,scen)); 
xaxis_exp_ind=find(strcmp(strvar_exp,xaxis)); 
yaxis_exp_ind=find(strcmp(strvar_exp,yaxis)); 
multi_exp_ind=find(strcmp(strvar_exp,multi)); 
cond_exp_ind=find(strcmp(strvar_exp,cond)); 

scen_cfd_ind=find(strcmp(strvar_cfd,scen)); 
xaxis_cfd_ind=find(strcmp(strvar_cfd,xaxis)); 
yaxis_cfd_ind=find(strcmp(strvar_cfd,yaxis));
multi_cfd_ind=find(strcmp(strvar_cfd,multi)); 

scen_exp_var=cell2mat({database_exp.(strvar_exp{scen_exp_ind})}');
xaxis_exp_var=cell2mat({database_exp.(strvar_exp{xaxis_exp_ind})}');
yaxis_exp_var=cell2mat({database_exp.(strvar_exp{yaxis_exp_ind})}');
multi_exp_var=cell2mat({database_exp.(strvar_exp{multi_exp_ind})}');
cond_exp_var=({database_exp.(strvar_exp{cond_exp_ind})}');

scen_cfd_var=cell2mat({database_cfd.(strvar_cfd{scen_cfd_ind})}');
xaxis_cfd_var=cell2mat({database_cfd.(strvar_cfd{xaxis_cfd_ind})}');
yaxis_cfd_var=cell2mat({database_cfd.(strvar_cfd{yaxis_cfd_ind})}');
multi_cfd_var=cell2mat({database_cfd.(strvar_cfd{multi_cfd_ind})}');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(scen,'amplitude')==1
    scen_inp=intersect(unique(round(scen_exp_var)),unique(round(scen_cfd_var)));
elseif strcmp(scen,'object')==1
    scen_inp=intersect(unique(scen_exp_var,'rows'),unique(scen_cfd_var,'rows'),'rows');
else
    scen_inp=intersect(unique((scen_exp_var)),unique((scen_cfd_var)));
end

if strcmp(xaxis,'amplitude')==1
    xaxis_inp=unique(cell2mat({database_exp.(strvar_exp{xaxis_exp_ind})}'));
    xaxis_inp2=unique(cell2mat({database_cfd.(strvar_cfd{xaxis_cfd_ind})}'));
else
    xaxis_inp=intersect(unique((xaxis_exp_var)),unique((xaxis_cfd_var)));
    xaxis_inp2=intersect(unique((xaxis_exp_var)),unique((xaxis_cfd_var)));
end

if strcmp(multi,'amplitude')==1
    multi_inp=intersect(unique(round(multi_exp_var)),unique(round(multi_cfd_var)));
elseif strcmp(multi,'object')==1
    multi_inp=intersect(unique(multi_exp_var,'rows'),unique(multi_cfd_var,'rows'),'rows');
else
    multi_inp=intersect(unique((multi_exp_var)),unique((multi_cfd_var)));
end

for k=1:length(multi_inp)
towew=1;
j=1;
figure;
axis([0 inf 0 inf]);
for i=1:length(scen_inp);
%% Definition of scen index
%%%% Experiment
if  isa(scen_inp(i),'double')==1 & strcmp(scen,'amplitude')==1
    scen_exp_ind2=find(floor(scen_exp_var)==scen_inp(i));
elseif isa(scen_inp(i),'double')==1
    scen_exp_ind2=find(scen_exp_var==scen_inp(i));
else
    scen_exp_ind2=strmatch(scen_inp(i,:), scen_exp_var, 'exact');
end

%%%% CFD
if  isa(scen_inp(i),'double')==1
    scen_cfd_ind2=find(scen_cfd_var==scen_inp(i));
else
    scen_cfd_ind2=strmatch(scen_inp(i,:), scen_cfd_var, 'exact');
end

%% Definition of xaxis index
%%%% Experiment
if  isa(xaxis_inp,'double')==1 & strcmp(xaxis,'amplitude')==1
    xaxis_exp_ind2=colon(1,size(xaxis_exp_var,1));
else
    length1_xaxis=1;
    length2_xaxis=0;
    for xaxis_loop=1:length(xaxis_inp)
        length2_xaxis=length2_xaxis+length(find(xaxis_exp_var==xaxis_inp(xaxis_loop)));
        xaxis_exp_ind2(length1_xaxis:length2_xaxis,1)=find(xaxis_exp_var==xaxis_inp(xaxis_loop));
        length1_xaxis=length1_xaxis+length(find(xaxis_exp_var==xaxis_inp(xaxis_loop)));
    end
end

%%%% CFD   
length1_xaxis=1;
length2_xaxis=0;
for xaxis_loop=1:length(xaxis_inp2)
    length2_xaxis=length2_xaxis+length(find(xaxis_cfd_var==xaxis_inp2(xaxis_loop)));
    xaxis_cfd_ind2(length1_xaxis:length2_xaxis,1)=find(xaxis_cfd_var==xaxis_inp2(xaxis_loop));
    length1_xaxis=length1_xaxis+length(find(xaxis_cfd_var==xaxis_inp2(xaxis_loop)));
end
%% Definition of multi index  
%%%% Experiment
if  isa(multi_inp(k,:),'double')==1 & strcmp(scen,'amplitude')==1
    multi_exp_ind2=find(round(multi_exp_var)==multi_inp(k,:));
elseif isa(multi_inp(k,:),'double')==1
    multi_exp_ind2=find(multi_exp_var==multi_inp(k,:));
else
    multi_exp_ind2=strmatch(multi_inp(k,:), multi_exp_var, 'exact');
end

%%%% CFD
if  isa(multi_inp(k,:),'double')==1
    multi_cfd_ind2=find(multi_cfd_var==multi_inp(k,:));
else
    multi_cfd_ind2=strmatch(multi_inp(k,:), multi_cfd_var, 'exact');
end

%% Definition of cond index
cond_exp_ind2=find(strcmp(cond_exp_var,cond_inp(1,:))==1);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
plotStyle1 = {'-ks','-kd','-ko','-k*','-k^','-k+','-kx','-k>','-kp','-kv','-kh','-k<','-k.'};
plotStyle2 = {':ks',':kd',':ko',':k*',':k^',':k+',':kx',':k>',':kp',':kv',':kh',':k<',':k.'};
inter1=(intersect(intersect(intersect(scen_exp_ind2,xaxis_exp_ind2),multi_exp_ind2),cond_exp_ind2))';
inter2=(intersect(intersect(scen_cfd_ind2,xaxis_cfd_ind2),multi_cfd_ind2))';

if strcmp(scen,'object')==1 && strcmp(xaxis,'amplitude')==1 && strcmp(yaxis,'damping_nondim')==1 && strcmp(multi,'period_nondim')==1
    pot_damping_nondim_exp(towew)=mean([database_exp(inter1).pot_damping_nondim]);
    pot_damping_nondim_cfd(towew)=mean([database_cfd(inter2).pot_damping_nondim]);
    towew=towew+1;
end

if strcmp(scen,'period_nondim')==1 && strcmp(xaxis,'amplitude')==1 && strcmp(yaxis,'damping_nondim')==1 && strcmp(multi,'object')==1
    pot_damping_nondim_exp(towew)=mean([database_exp(inter1).pot_damping_nondim]);
    pot_damping_nondim_cfd(towew)=mean([database_cfd(inter2).pot_damping_nondim]);
    towew=towew+1;
end
    
plot([xaxis_exp_var(inter1)],[yaxis_exp_var(inter1)],plotStyle2{j},'MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([xaxis_cfd_var(inter2)],[yaxis_cfd_var(inter2)],plotStyle1{j},'MarkerFaceColor','k');
if length(inter1)>0
    if strcmp(scen,'period_nondim')==1
        legendInfo{(2*j)-1} = ['Exp, ' '$T \sqrt{2g/B} = $' num2str(scen_inp(i),'%.2f')];
        legendInfo{2*j} = ['PVC2D-Roll ' '$T \sqrt{2g/B} = $' num2str(scen_inp(i),'%.2f')];
    elseif strcmp(scen,'amplitude')==1
        legendInfo{(2*j)-1} = ['Exp, ' '$\theta = ' num2str(scen_inp(i))  '^o$'];
        legendInfo{2*j} = ['PVC2D-Roll ' '$\theta = ' num2str(scen_inp(i))  '^o$'];
    else
        legendInfo{(2*j)-1} = ['Exp, ' scen_inp(i,:)];
        legendInfo{2*j} = ['PVC2D-Roll ' scen_inp(i,:)];
    end
else
end
if length(inter1)>0
    j=j+1;
else
    j=j;
end
end
if strcmp(yaxis,'addedmass_nondim')==1 & strcmp(xaxis,'period_nondim')==1
    plot((2*pi./Om_pot_BT2).*sqrt(2*9.81/2),A44_pot_BT2./(1000*2*2^2),'r');
    plot((2*pi./Om_pot_BT4).*sqrt(2*9.81/2),A44_pot_BT4./(1000*4*4^2),'b');
    legendInfo{end+1}='Potential A44 B/T=2';
    legendInfo{end+1}='Potential A44 B/T=4';
else
end
    
if strcmp(yaxis,'damping_nondim')==1
    if strcmp(scen,'object')==1
        hl=legend(legendInfo,'Location','northwest');
    else
        hl=legend(legendInfo,'Location','northeastoutside');
    end
else
    if strcmp(scen,'object')==1
        hl=legend(legendInfo,'Location','northeast');
    else
        hl=legend(legendInfo,'Location','northeastoutside');
    end
end

set(hl, 'Interpreter', 'latex');
if strcmp(yaxis,'addedmass_nondim')==1
    if strcmp(xaxis,'amplitude')==1
        hl=xlabel('$\theta (deg)$','FontSize', 15);
        set(hl, 'Interpreter', 'latex');
    else
        hl=xlabel('$T \sqrt{2g/B}$','FontSize', 15);
        set(hl, 'Interpreter', 'latex');
    end
    hl=ylabel('$a_{44} / \rho A B^2$','FontSize', 15);
    set(hl, 'Interpreter', 'latex');
else
    if strcmp(xaxis,'amplitude')==1
        hl=xlabel('$\theta (deg)$','FontSize', 15);
        set(hl, 'Interpreter', 'latex');
    else
        hl=xlabel('$T \sqrt{2g/B}$','FontSize', 15);
        set(hl, 'Interpreter', 'latex');
    end
    hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
    set(hl, 'Interpreter', 'latex');
end
if strcmp(multi,'object')==1
    hl=title(['$Case  ' multi_inp(k,:) ' $'],'FontSize', 15);
    set(hl, 'Interpreter', 'latex');
elseif strcmp(multi,'amplitude')==1
    title(['$Case \theta = ' num2str(multi_inp(k)) '^o $'],'FontSize', 15);
else
    hl=title(['Case ' '$T \sqrt{2g/B} =$' num2str(multi_inp(k),'%.2f')],'FontSize', 15);
    set(hl, 'Interpreter', 'latex');
end
grid on
% axis auto
pbaspect([1 1 1])
if strcmp(scen,'period_nondim')==1 & strcmp(xaxis,'amplitude')==1 & strcmp(yaxis,'damping_nondim')==1
    axis ([-0.5 17 0 0.35]);
elseif strcmp(scen,'object')==1 & strcmp(xaxis,'amplitude')==1 & strcmp(yaxis,'damping_nondim')==1
    axis ([-0.5 17 0 0.35]);
elseif strcmp(scen,'amplitude')==1 & strcmp(xaxis,'period_nondim')==1 & strcmp(yaxis,'damping_nondim')==1
    axis ([6 13 0 0.35]);
elseif strcmp(scen,'object')==1 & strcmp(xaxis,'amplitude')==1 & strcmp(yaxis,'addedmass_nondim')==1
    axis ([0 17 0 0.37]);
elseif strcmp(scen,'period_nondim')==1 & strcmp(xaxis,'amplitude')==1 & strcmp(yaxis,'addedmass_nondim')==1
    axis ([0 17 0 0.37]);
elseif strcmp(scen,'amplitude')==1 & strcmp(xaxis,'period_nondim')==1 & strcmp(yaxis,'addedmass_nondim')==1
    axis ([6 13 0 0.37]);;
end
if strcmp(scen,'object')==1 && strcmp(xaxis,'amplitude')==1 && strcmp(yaxis,'damping_nondim')==1 && strcmp(multi,'period_nondim')==1
plot(0,pot_damping_nondim_exp(1),plotStyle2{1},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(1),plotStyle2{1},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(2),plotStyle2{2},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(2),plotStyle2{2},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(3),plotStyle2{3},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(3),plotStyle2{3},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(4),'r*')
plot(0,pot_damping_nondim_cfd(4),'b*')
end

if strcmp(scen,'period_nondim')==1 && strcmp(xaxis,'amplitude')==1 && strcmp(yaxis,'damping_nondim')==1 && strcmp(multi,'object')==1
plot(0,pot_damping_nondim_exp(1),plotStyle2{1},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(1),plotStyle2{1},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(2),plotStyle2{2},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(2),plotStyle2{2},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(3),plotStyle2{3},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(3),plotStyle2{3},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(4),plotStyle2{4},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(4),plotStyle2{4},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(5),plotStyle2{5},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(5),plotStyle2{5},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(6),plotStyle2{6},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(6),plotStyle2{6},'MarkerFaceColor','b')
plot(0,pot_damping_nondim_exp(7),plotStyle2{7},'MarkerFaceColor','r')
plot(0,pot_damping_nondim_cfd(7),plotStyle2{7},'MarkerFaceColor','b')
end
hold off
clearvars -except database_exp database_cfd k i multi_inp xaxis_inp2 xaxis_inp scen_inp multi_cfd_var yaxis_cfd_var xaxis_cfd_var scen_cfd_var cond_exp_var multi_exp_var yaxis_exp_var xaxis_exp_var scen_exp_var multi_cfd_ind yaxis_cfd_ind xaxis_cfd_ind scen_cfd_ind cond_exp_ind multi_exp_ind yaxis_exp_ind xaxis_exp_ind scen_exp_ind strvar_cfd strvar_exp scen xaxis yaxis multi cond cond_inp Om_pot_BT2 A44_pot_BT2 Om_pot_BT4 A44_pot_BT4
end


