close all; clear all; clc;
load(['M:\thesismatlab\Experiment\database_exp.mat']);
% load(['M:\thesismatlab\CFD\database_cfd_newz.mat']);
load(['M:\thesismatlab\CFD\database_cfd.mat']);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Experiment Hydrodynamic Coefficient Extraction
% [database_exp,database_cfd]=HydCoeff(database_exp,database_cfd);
[SS_exp,SS_cfd]=ExtSS(database_exp,database_cfd,1,21);
[database_exp,database_cfd]=HydCoeff(database_exp,database_cfd,SS_exp,SS_cfd);
% [database_exp,database_cfd]=HydCoeff2(database_exp,database_cfd,SS_exp,SS_cfd);

% Time-series check
% MotForC(SS_exp,SS_cfd,amplitude,period,object);
MotForC(SS_exp,SS_cfd,13.00,2.0,'BB3');
MotForC2(SS_exp,SS_cfd,12.00,1.00,'BB2');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bilge-Box Force Extraction
[bb_force_exp,bb_force_cfd]=bbforce(database_exp,SS_cfd);
BBForC(bb_force_exp,bb_force_cfd,2,1.35,'BB2');
BBForC2(bb_force_exp,bb_force_cfd,2,1.00,'BB2');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Precision Error Estimation
repstruct=StudentT(database_exp,1); %repstruct=StudentT(database_exp,iplot), if iplot==1 >> plot figures

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Plot Damping and Added-mass curves  
%HydCurve('legend','xlabel','ylabel','title',database_exp,database_cfd);
HydCurve('object','amplitude','damping_nondim','period_nondim',database_exp,database_cfd);
HydCurve('period_nondim','amplitude','damping_nondim','object',database_exp,database_cfd);
HydCurve('amplitude','period_nondim','damping_nondim','object',database_exp,database_cfd);

HydCurve('object','amplitude','pot_damping','period_nondim',database_exp,database_cfd);
HydCurve('object','amplitude','pot_damping2','period_nondim',database_exp,database_cfd);

HydCurve('object','amplitude','addedmass_nondim','period_nondim',database_exp,database_cfd);
HydCurve('period_nondim','amplitude','addedmass_nondim','object',database_exp,database_cfd);
HydCurve('amplitude','period_nondim','addedmass_nondim','object',database_exp,database_cfd);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Plot Bilge-Boxes Force Coefficients
% BBFCurve('legend','xlabel','ylabel','title',database_exp);
BBFCurve('object','KC','a33_bb_port','period_nondim',bb_force_exp,bb_force_cfd);
BBFCurve('object','KC','a33_bb_starboard','period_nondim',bb_force_exp,bb_force_cfd);
BBFCurve('object','KC','b33_bb_port','period_nondim',bb_force_exp,bb_force_cfd);
BBFCurve('object','KC','b33_bb_starboard','period_nondim',bb_force_exp,bb_force_cfd);

BBFCurve('period_nondim','KC','a33_bb_port','object',bb_force_exp,bb_force_cfd);
BBFCurve('period_nondim','KC','a33_bb_starboard','object',bb_force_exp,bb_force_cfd);
BBFCurve('period_nondim','KC','b33_bb_port','object',bb_force_exp,bb_force_cfd);
BBFCurve('period_nondim','KC','b33_bb_starboard','object',bb_force_exp,bb_force_cfd);

BBFCurve('period_nondim','amplitude','Mz_starboard_nondim_mean','object',bb_force_exp,bb_force_cfd);

% BBFCurve('object','KC','CM_port','period',bb_force_exp,bb_force_cfd);
% BBFCurve('object','KC','CM_starboard','period',bb_force_exp,bb_force_cfd);
% BBFCurve('object','KC','CD_port','period',bb_force_exp,bb_force_cfd);
% BBFCurve('object','KC','CD_starboard','period',bb_force_exp,bb_force_cfd);
% 
% BBFCurve('period','KC','CM_port','object',bb_force_exp,bb_force_cfd);
% BBFCurve('period','KC','CM_starboard','object',bb_force_exp,bb_force_cfd);
% BBFCurve('period','KC','CD_port','object',bb_force_exp,bb_force_cfd);
% BBFCurve('period','KC','CD_bb_starboard','object',bb_force_exp,bb_force_cfd);