function MotForC(SS_exp,SS_cfd,amplitude,period,object);
% close all;
load(['M:\thesismatlab\Main Postproc\variables.mat']);
%%% Definition of cross section area, I44 and C44
if object=='RC0';
    A=((B*(D-RC))+(RC*(B-(2*RC)))+(0.5*pi*RC^2));
    I44=0.92/t1; %[kgm^2]
    GM=0.12874;
    C44=rho*g*A*GM;
elseif object=='RC_';
    A=((B*(D-RC))+(RC*(B-(2*RC)))+(0.5*pi*RC^2));
    I44=0.92/t1; %[kgm^2]
    GM=0.12874;
    C44=rho*g*A*GM;
elseif object=='BB1';
    A=((B*D)+(t*BB1));
    I44=1.06/t1; %[kgm^2]
    GM=0.12248;
    C44=rho*g*A*GM;
elseif object=='BB2';
    A=((B*D)+(t*BB2));
    I44=1.14/t1; %[kgm^2]
    GM=0.12049;
    C44=rho*g*A*GM;
elseif object=='BB3';
    A=((B*D)+(t*BB3));
    I44=1.26/t1; %[kgm^2]
    GM=0.1165;
    C44=rho*g*A*GM;
else
    A=((B*D)+(t*BB3));
    I44=1.26/t1; %[kgm^2]
    GM=0.1165;
    C44=rho*g*A*GM;
end

index1=find(ismember({SS_exp.object}, object));
index2=find(round(cell2mat({SS_exp.amplitude}))==amplitude);
index3=find([SS_exp.period]==period);
index_exp=intersect(intersect(index1,index2),index3);
srcdata_exp = SS_exp(index_exp);

index4=find(ismember({SS_cfd.object}, object));
index5=find([SS_cfd.amplitude]==amplitude);
index6=find([SS_cfd.period]==period);
index_cfd=intersect(intersect(index4,index5),index6);
srcdata_cfd = SS_cfd(index_cfd);

[exp_a,exp_b]=findpeaks(srcdata_exp.eta4); exp_a=exp_b(1); exp_b=exp_b(end);
[cfd_a,cfd_b]=findpeaks(srcdata_cfd.eta4_imposed); cfd_a=cfd_b(1); cfd_b=cfd_b(end);


figure;
plot([srcdata_exp.time_before],[srcdata_exp.M_exc_before./t1],'--','MarkerFaceColor',[0.2 0.2 0.2]); hold on;
plot([srcdata_exp.time],[srcdata_exp.M_exc./t1],'r');
legend('Full time series','Damping extract window');
grid on
xlabel('Time (s)','FontSize', 15);
hl=ylabel('$M_x (N.m)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title('Damping extract window (Experiment)');

figure;
plot([srcdata_cfd.t_postproc_before],[-srcdata_cfd.M_Totaldyn_before./t2],'--','MarkerFaceColor',[0.2 0.2 0.2]); hold on;
plot([srcdata_cfd.t_postproc],[-srcdata_cfd.M_Totaldyn./t2],'r');
legend('Full time series','Damping extract window');
grid on
xlabel('Time (s)','FontSize', 15);
hl=ylabel('$M_x (N.m)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title('Damping extract window (CFD)');

figure;
subplot(4,1,1);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[srcdata_exp.eta4(exp_a:exp_b)],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[srcdata_cfd.eta4_imposed(cfd_a:cfd_b)],'k');
legend({'Experiment','CFD'},'Position',[0.45 0.84 0.1 0.1],'Orientation','horizontal');
grid on
hl=ylabel('$\theta (Deg)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
axis fill;

subplot(4,1,2);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[srcdata_exp.eta4dot(exp_a:exp_b)],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[srcdata_cfd.eta4dot_imposed(cfd_a:cfd_b)],'k');
grid on
hl=ylabel('$\dot{\theta} (Deg/s)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
axis fill;

subplot(4,1,3);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[srcdata_exp.eta4dotdot(exp_a:exp_b)],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[srcdata_cfd.eta4dotdot_imposed(cfd_a:cfd_b)],'k');
grid on
hl=ylabel('$\ddot{\theta} (Deg/s^2)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
axis fill;

subplot(4,1,4);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[(srcdata_exp.M_exc(exp_a:exp_b)./t1)-(I44.*srcdata_exp.eta4dotdot(exp_a:exp_b)*(pi/180))-(C44.*srcdata_exp.eta4(exp_a:exp_b)*(pi/180))],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[-srcdata_cfd.M_Totaldyn(cfd_a:cfd_b)./t2],'k');
grid on
xlabel('Time (s)','FontSize', 15);
hl=ylabel('$M_x (N.m)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
axis fill;

suptitle(['Case ' object ' \theta = ' num2str(amplitude) '^o , T = ' num2str(period) ' secs']);

figure;
subplot(2,1,1);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[-srcdata_exp.WP1(exp_a:exp_b)],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[-srcdata_exp.WP2(exp_a:exp_b)],'--','MarkerFaceColor',[0.5 0.5 0.5]); 
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[srcdata_cfd.pgh_right_x125(cfd_a:cfd_b)/9.81],'r');
grid on
xlabel('Time (s)','FontSize', 15);
hl=ylabel('$\zeta_a (m)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
legend('WP1_{exp}','WP2_{exp}','WP_{Right,CFD}');
axis fill;

subplot(2,1,2);
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[-srcdata_exp.WP3(exp_a:exp_b)],'--','MarkerFaceColor',[0.8 0.8 0.8]); hold on;
plot([srcdata_exp.time(exp_a:exp_b)-srcdata_exp.time(exp_a)],[-srcdata_exp.WP4(exp_a:exp_b)],'--','MarkerFaceColor',[0.5 0.5 0.5]); 
plot([srcdata_cfd.t_imposed(cfd_a:cfd_b)-srcdata_cfd.t_imposed(cfd_a)],[srcdata_cfd.pgh_left_x125(cfd_a:cfd_b)/9.81],'r');
grid on
xlabel('Time (s)','FontSize', 15);
hl=ylabel('$\zeta_a (m)$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
xlim([0 8]);
axis fill;
legend('WP3_{exp}','WP4_{exp}','WP_{Left,CFD}');
end



