function repstruct=StudentT(database_exp,iplot);
t_student=12.70620474;
repind = [547:637];
repstruct(length(repind)) = struct();
chnames = { 
'object'
'amplitude'
'period'
'damping_nondim_s'
}; 
fhyd=1;
for i=repind
   srcdata1 = database_exp(i);
   srcdata2 = database_exp(i+182);
   for chi = 1:length(chnames);
       chname = chnames{chi};
       if isa(database_exp(i).(chname),'char')==1
           repstruct(fhyd).(chname)= getfield(srcdata1,chname);
       else length(database_exp(i).(chname))==1
           if strcmp(chname,'damping_nondim_s')==1
               repstruct(fhyd).(chname)= getfield(srcdata1,chname);
               repstruct(fhyd).([chname '_rep'])= getfield(srcdata2,chname);
           else
               repstruct(fhyd).(chname)= getfield(srcdata1,chname);
           end
       end
   end
   N=2; %Number of repetitions
   repstruct(fhyd).mean=(repstruct(fhyd).damping_nondim_s+repstruct(fhyd).damping_nondim_s_rep)/2;
   repstruct(fhyd).Sx=sqrt((1/(N-1))*(repstruct(fhyd).damping_nondim_s-repstruct(fhyd).mean)^2+(repstruct(fhyd).damping_nondim_s_rep-repstruct(fhyd).mean)^2);
   repstruct(fhyd).Sx_mean=repstruct(fhyd).Sx/sqrt(N);
   repstruct(fhyd).P_lim=t_student*repstruct(fhyd).Sx_mean;
   repstruct(fhyd).Unc=(repstruct(fhyd).P_lim/repstruct(fhyd).mean)*100;
   fhyd=fhyd+1;
end
if iplot==1
x=[1:4:49;4:4:52;55:3:91];
T=[1.00,1.50,2.00];
figure;
subplot(3,2,1)
plot([repstruct(x(1,:)).amplitude],[repstruct(x(1,:)).damping_nondim_s],'b+-');hold on;
plot([repstruct(x(1,:)).amplitude],[repstruct(x(1,:)).damping_nondim_s_rep],'g*-');
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Test condition T = ' num2str(T(1)) ' secs'],'FontSize', 15);
subplot(3,2,2)
errorbar([repstruct(x(1,:)).amplitude],[repstruct(x(1,:)).mean],[repstruct(x(1,:)).Sx_mean],'k-','LineWidth',1.5);
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Standard deviation of test T = ' num2str(T(1)) ' secs'],'FontSize', 15);

subplot(3,2,3)
plot([repstruct(x(2,:)).amplitude],[repstruct(x(2,:)).damping_nondim_s],'b+-');hold on;
plot([repstruct(x(2,:)).amplitude],[repstruct(x(2,:)).damping_nondim_s_rep],'g*-');
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Test condition T = ' num2str(T(1)) ' secs'],'FontSize', 15);
subplot(3,2,4)
errorbar([repstruct(x(2,:)).amplitude],[repstruct(x(2,:)).mean],[repstruct(x(2,:)).Sx_mean],'k-','LineWidth',1.5);
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Standard deviation of test T = ' num2str(T(2)) ' secs'],'FontSize', 15);

subplot(3,2,5)
plot([repstruct(x(3,:)).amplitude],[repstruct(x(3,:)).damping_nondim_s],'b+-');hold on;
plot([repstruct(x(3,:)).amplitude],[repstruct(x(3,:)).damping_nondim_s_rep],'g*-');
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Test condition T = ' num2str(T(1)) ' secs'],'FontSize', 15);
legend('April 2017 Test','May 2017 Test');
subplot(3,2,6)
errorbar([repstruct(x(3,:)).amplitude],[repstruct(x(3,:)).mean],[repstruct(x(3,:)).Sx_mean],'k-','LineWidth',1.5);
grid on
xlabel('Amplitude (Deg)','FontSize', 15);
hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
set(hl, 'Interpreter', 'latex');
title(['Standard deviation of test T = ' num2str(T(3)) ' secs'],'FontSize', 15);
else
end
% if iplot==1
% x=[1:4:49;2:4:50;3:4:51;4:4:52;53:3:89;54:3:90;55:3:91];
% T=[1.00,1.15,1.35,1.50,1.70,1.85,2.00];
% figure;
% col=3;
% for i=1:size(x,1)
% subplot(ceil(length(T)/col),col,i)
% plot([repstruct(x(i,:)).amplitude],[repstruct(x(i,:)).damping_nondim_s],'b+-');hold on;
% plot([repstruct(x(i,:)).amplitude],[repstruct(x(i,:)).damping_nondim_s_rep],'g*-');
% errorbar([repstruct(x(i,:)).amplitude],[repstruct(x(i,:)).mean],[repstruct(x(i,:)).Sx_mean],'ks:','MarkerFaceColor','r','LineWidth',1.5);
% hold off;
% grid on
% xlabel('Amplitude (Deg)','FontSize', 15);
% hl=ylabel('$b_{44} \sqrt{B/2g} / \rho A B^2$','FontSize', 15);
% set(hl, 'Interpreter', 'latex');
% title(['Test condition T = ' num2str(T(i)) ' secs'],'FontSize', 15);
% end
% legend('April 2017 Test','Repetition Test','Mean Value + Uncertainty','Location','northwestoutside');
% else
% end
end
       