function [cutdata_force_exp,cutdata_force_cfd]=bbforce(database_exp,cutdata_cfd);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Hydrodynamic Force on Bilge Boxes Extraction
load(['M:\thesismatlab\Main Postproc\variables.mat']);
waterairsbtrct = [183:273,365:455,547:637];
cutdata_force_exp(length(waterairsbtrct)) = struct();
chnames = { 
'object'
'amplitude'
'period'
'time'
'eta4'
'Fy_A'
'Fy_B'
'Fy_C'
'Fy_D'
'Fz_A'
'Fz_B'
'Fz_C'
'Fz_D'
}; 
fhyd=1;
% n-th peak
f_peak_dl=1;
f_peak_ul=31;
n_f_oscil=f_peak_ul-f_peak_dl;
for i=waterairsbtrct
   srcdata1 = database_exp(i);
   srcdata2 = database_exp(i+91);
   [water_peak,water_index]=findpeaks(srcdata1.eta4);
   dl_water=water_index(f_peak_dl); ul_water=water_index(f_peak_ul);
   [air_peak,air_index]=findpeaks(srcdata2.eta4);
   dl_air=air_index(f_peak_dl); ul_air=air_index(f_peak_ul);
   for chi = 1:length(chnames)
       chname = chnames{chi};
       if isa(database_exp(i).(chname),'char')==1
           cutdata_force_exp(fhyd).(chname)= getfield(srcdata1,chname);
       elseif chname(1)=='t' 
           time_cut1=getfield(srcdata1,chname); time_cut1=time_cut1(dl_water:ul_water);
           time_cut2=getfield(srcdata2,chname); time_cut2=time_cut2(dl_air:ul_air);
           if length(time_cut1)==length(time_cut2)
               cutdata_force_exp(fhyd).(chname)= time_cut1;
           elseif length(time_cut1)>length(time_cut2)
               cutdata_force_exp(fhyd).(chname)= time_cut2;
           elseif length(time_cut1)<length(time_cut2)
               cutdata_force_exp(fhyd).(chname)= time_cut1;
           end
        elseif chname(1)=='e' 
           eta_cut1=getfield(srcdata1,chname); eta_cut1=eta_cut1(dl_water:ul_water);
           eta_cut2=getfield(srcdata2,chname); eta_cut2=eta_cut2(dl_air:ul_air);
           if length(eta_cut1)==length(eta_cut2)
               cutdata_force_exp(fhyd).(chname)= eta_cut1;
           elseif length(eta_cut1)>length(eta_cut2)
               cutdata_force_exp(fhyd).(chname)= eta_cut2;
           elseif length(eta_cut1)<length(eta_cut2)
               cutdata_force_exp(fhyd).(chname)= eta_cut1;
           end    
       elseif length(database_exp(i).(chname))==1
           cutdata_force_exp(fhyd).(chname)= getfield(srcdata1,chname);
       else
           arr1 = getfield(srcdata1,chname); arr1=arr1(dl_water:ul_water); 
           arr2 = getfield(srcdata2,chname); arr2=arr2(dl_air:ul_air);
           if length(arr1)==length(arr2)
            cutdata_force_exp(fhyd).(chname)=arr2-arr1;
            elseif length(arr1)>length(arr2)
            cutdata_force_exp(fhyd).(chname)=arr2-arr1(1:(end-abs(length(arr1)-length(arr2))));   
            else
            cutdata_force_exp(fhyd).(chname)=arr2(1:(end-abs(length(arr1)-length(arr2))))-arr1; 
            end
       end
   end
   
   cutdata_force_exp(fhyd).period_nondim=cutdata_force_exp(fhyd).period*sqrt(2*g/B);
   cutdata_force_exp(fhyd).time=cutdata_force_exp(fhyd).time-cutdata_force_exp(fhyd).time(1);
   cutdata_force_exp(fhyd).Fy_starboard=((cutdata_force_exp(fhyd).Fy_A+cutdata_force_exp(fhyd).Fy_B))/t1;
   cutdata_force_exp(fhyd).Fy_port=((cutdata_force_exp(fhyd).Fy_C+cutdata_force_exp(fhyd).Fy_D))/t1;
   cutdata_force_exp(fhyd).Fz_starboard=((cutdata_force_exp(fhyd).Fz_A+cutdata_force_exp(fhyd).Fz_B))/t1;
   cutdata_force_exp(fhyd).Fz_port=((cutdata_force_exp(fhyd).Fz_C+cutdata_force_exp(fhyd).Fz_D))/t1;
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bilge boxes KC-number and local oscillation definition
   if cutdata_force_exp(fhyd).object=='BB1'
       A=((B*D)+(t*BB1));
       l_bb=BB1/2;
       A_bb=t*l_bb;
   elseif cutdata_force_exp(fhyd).object=='BB2'
       A=((B*D)+(t*BB2));
       l_bb=BB2/2;
       A_bb=t*l_bb;
   else
       A=((B*D)+(t*BB3));
       l_bb=BB3/2;
       A_bb=t*l_bb;
   end
   
   cutdata_force_exp(fhyd).Mz_starboard_nondim=(cutdata_force_exp(fhyd).Fz_starboard*l_bb/2)/(rho*A*(l_bb^2)*(2*g/B));
   cutdata_force_exp(fhyd).Mz_starboard_nondim_mean=(abs(mean(findpeaks(cutdata_force_exp(fhyd).Mz_starboard_nondim,cutdata_force_exp(fhyd).time,'MinPeakDistance',cutdata_force_exp(fhyd).period-0.1)))+abs(mean(findpeaks(-cutdata_force_exp(fhyd).Mz_starboard_nondim,cutdata_force_exp(fhyd).time,'MinPeakDistance',cutdata_force_exp(fhyd).period-0.1))))/2;

   cutdata_force_exp(fhyd).KC=R_bb*cutdata_force_exp(fhyd).amplitude*(pi/180)*pi/l_bb;
   
   cutdata_force_exp(fhyd).eta4loc_sb=-R_bb*cutdata_force_exp(fhyd).eta4*pi/180;
   cutdata_force_exp(fhyd).eta4loc_p=R_bb*cutdata_force_exp(fhyd).eta4*pi/180; 
   
   cutdata_force_exp(fhyd).eta4dotloc_sb=gradient(cutdata_force_exp(fhyd).eta4loc_sb,dt); 
   cutdata_force_exp(fhyd).eta4dotloc_p=gradient(cutdata_force_exp(fhyd).eta4loc_p,dt); 
   
   cutdata_force_exp(fhyd).eta4dotdotloc_sb=gradient(cutdata_force_exp(fhyd).eta4dotloc_sb,dt); 
   cutdata_force_exp(fhyd).eta4dotdotloc_p=gradient(cutdata_force_exp(fhyd).eta4dotloc_p,dt);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bilge boxes post-processing
   chnames2 = { 
   'time'
   'eta4loc_sb'
   'eta4loc_p'
   'eta4dotloc_sb'
   'eta4dotloc_p'
   'eta4dotdotloc_sb'
   'eta4dotdotloc_p'
   'Fy_starboard'
   'Fy_port'
   'Fz_starboard'
   'Fz_port'
   }; 

%% Give ramp to the time-series
   nramp = 5; %ramp period 
   for chi2 = 1:length(chnames2)
       chname2 = chnames2{chi2};
       if strcmp(chname2,'time')==1
           cutdata_force_exp(fhyd).(chname2)=cutdata_force_exp(fhyd).(chname2);
       else
           cutdata_force_exp(fhyd).(chname2)=rampfunct(cutdata_force_exp(fhyd).time,cutdata_force_exp(fhyd).(chname2),nramp);
       end
   end

%% IF YOU WANT TO PUT HARMONICS EXTRACTION FROM THE RAMPED TIME SERIES

   
%% Extract the steady part
   [bb_peak,bb_index]=findpeaks(cutdata_force_exp(fhyd).eta4);
   bb_dl=bb_index(nramp+1); bb_ul=bb_index(length(bb_index)-3*nramp);
   for chi2 = 1:length(chnames2)
       chname2 = chnames2{chi2};
       cutsteady=cutdata_force_exp(fhyd).(chname2);
       cutdata_force_exp(fhyd).(chname2)=cutsteady(bb_dl:bb_ul);
   end

%% Local motion and force new variable declaration (just for shortening the formula below)
time_bb=cutdata_force_exp(fhyd).time;

pos_sb=cutdata_force_exp(fhyd).eta4loc_sb;
vel_sb=cutdata_force_exp(fhyd).eta4dotloc_sb;
acc_sb=cutdata_force_exp(fhyd).eta4dotdotloc_sb;

pos_p=cutdata_force_exp(fhyd).eta4loc_p;
vel_p=cutdata_force_exp(fhyd).eta4dotloc_p;
acc_p=cutdata_force_exp(fhyd).eta4dotdotloc_p;

Fy_sb=cutdata_force_exp(fhyd).Fy_starboard;
Fz_sb=cutdata_force_exp(fhyd).Fz_starboard;

Fy_p=cutdata_force_exp(fhyd).Fy_port;
Fz_p=cutdata_force_exp(fhyd).Fz_port;

%% Local added-mass and damping coefficient extraction 
   cutdata_force_exp(fhyd).a33_bb_starboard=...
   trapz(time_bb,Fz_sb.*acc_sb)./trapz(time_bb,acc_sb.*acc_sb)./...
   (rho*pi*(l_bb/2)^2); 
   
   cutdata_force_exp(fhyd).a33_bb_port=...
   trapz(time_bb,Fz_p.*acc_p)./trapz(time_bb,acc_p.*acc_p)./...
   (rho*pi*(l_bb/2)^2); 
   
   cutdata_force_exp(fhyd).b33_bb_starboard=...
   trapz(time_bb,Fz_sb.*vel_sb)./trapz(time_bb,vel_sb.*vel_sb).*...
   (sqrt(l_bb/(2*g))/(rho*A_bb));
   
   cutdata_force_exp(fhyd).b33_bb_port=...
   trapz(time_bb,Fz_p.*vel_p)./trapz(time_bb,vel_p.*vel_p).*...
   (sqrt(l_bb/(2*g))/(rho*A_bb));   

%% Morison model coefficients
   f_mor_bpass=1/cutdata_force_exp(fhyd).period;
   om_mor_bpass=2*pi*f_mor_bpass;
   
   pos_sb_1om=bpass(pos_sb,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0);
   pos_p_1om=bpass(pos_p,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0);
   vel_sb_1om=bpass(vel_sb,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0); 
   vel_p_1om=bpass(vel_p,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0); 
   acc_sb_1om=bpass(acc_sb,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0); 
   acc_p_1om=bpass(acc_p,dt,f_mor_bpass-0.1,f_mor_bpass+0.1,0);
   amp_pos=(mean(findpeaks(pos_p_1om))+mean(findpeaks(-pos_p_1om)))/2;
   
   const_mor_add=(rho*pi*(l_bb^2)/2);
   cutdata_force_exp(fhyd).CM_starboard=...
       trapz(time_bb,Fz_sb.*acc_sb_1om)./...
       trapz(time_bb,const_mor_add*acc_sb_1om.*acc_sb_1om);
   cutdata_force_exp(fhyd).CM_port=...
       trapz(time_bb,Fz_p.*acc_p_1om)./...
       trapz(time_bb,const_mor_add*acc_p_1om.*acc_p_1om);
   
   const_mor_drag=0.5*rho*l_bb*amp_pos*om_mor_bpass*(8/(3*pi));
   cutdata_force_exp(fhyd).CD_starboard=...
       trapz(time_bb,Fz_sb.*vel_sb_1om)./...
       trapz(time_bb,const_mor_drag*vel_sb_1om.*vel_sb_1om);
   cutdata_force_exp(fhyd).CD_port=...
       trapz(time_bb,Fz_p.*vel_p_1om)./...
       trapz(time_bb,const_mor_drag*vel_p_1om.*vel_p_1om);   
   
   cutdata_force_exp(fhyd).F_Morr_sb=...
   (const_mor_drag*cutdata_force_exp(fhyd).CD_starboard*vel_sb_1om)+...
   (const_mor_add*cutdata_force_exp(fhyd).CM_starboard*acc_sb_1om);

   cutdata_force_exp(fhyd).F_Morr_p=...
   (const_mor_drag*cutdata_force_exp(fhyd).CD_port*vel_p_1om)+...
   (const_mor_add*cutdata_force_exp(fhyd).CM_port*acc_p_1om);

fhyd=fhyd+1;
end
x=round(rand(1)*10)*round(rand(1)*10);
% %% Check Morisson model
figure;
plot(cutdata_force_exp(x).time,cutdata_force_exp(x).Fz_starboard,cutdata_force_exp(x).time,cutdata_force_exp(x).F_Morr_sb);
xlabel('Time (s)');
ylabel('Force (N)');
legend('Measured','Morisson Model');
grid on

% %% Check dynamic model
figure;
if cutdata_force_exp(x).object=='BB1'
   l_bb=BB1/2;
elseif cutdata_force_exp(x).object=='BB2'
   l_bb=BB2/2;
else
   l_bb=BB3/2;
end

A_bb=l_bb*t;

plot(cutdata_force_exp(x).time,cutdata_force_exp(x).Fz_starboard);
hold on;
plot(cutdata_force_exp(x).time,(cutdata_force_exp(x).a33_bb_starboard*(0.5*rho*pi*(l_bb/2)^2)*cutdata_force_exp(x).eta4dotdotloc_sb)+((cutdata_force_exp(x).b33_bb_starboard/(sqrt(l_bb/(2*g))/(rho*A_bb)))*cutdata_force_exp(x).eta4dotloc_sb));
xlabel('Time (s)');
ylabel('Force (N)');
legend('Measurement','Dynamic model');
grid on
hold off;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% CFD Bilge Box Force Extraction
chnames3 = { 
'object'
'amplitude'
'period'
't_imposed'
'eta4_imposed'
'eta4dot_imposed'
'eta4dotdot_imposed'
't_postproc'
'Fy_BKLdyn'
'Fz_BKLdyn'
'Fy_BKRdyn'
'Fz_BKRdyn'
}; 
cutdata_force_cfd(size(cutdata_cfd,2)) = struct();  
for i=1:size(cutdata_cfd,2)
    srcdata3 = cutdata_cfd(i);
    for chi3 = 1:length(chnames3)
       chname3 = chnames3{chi3};
       cutdata_force_cfd(i).(chname3)=getfield(srcdata3,chname3);
    end
    cutdata_force_cfd(i).Fz_port=(-cutdata_force_cfd(i).Fy_BKLdyn.*sind(cutdata_force_cfd(i).eta4_imposed))+(cutdata_force_cfd(i).Fz_BKLdyn.*cosd(cutdata_force_cfd(i).eta4_imposed))/t2;
    cutdata_force_cfd(i).Fz_starboard=(-cutdata_force_cfd(i).Fy_BKRdyn.*sind(cutdata_force_cfd(i).eta4_imposed))+(cutdata_force_cfd(i).Fz_BKRdyn.*cosd(cutdata_force_cfd(i).eta4_imposed))/t2;
    dt2=cutdata_force_cfd(i).t_postproc(2)-cutdata_force_cfd(i).t_postproc(1);

%% Bilge boxes KC-number and local oscillation definition
   if cutdata_force_cfd(i).object=='BB1'
       A=((B*D)+(t*BB1));
       l_bb=BB1/2;
       A_bb=t*l_bb;
   elseif cutdata_force_cfd(i).object=='BB2'
       A=((B*D)+(t*BB2));
       l_bb=BB2/2;
       A_bb=t*l_bb;
   else
       A=((B*D)+(t*BB3));
       l_bb=BB3/2;
       A_bb=t*l_bb;
   end
   
   cutdata_force_cfd(i).period_nondim=cutdata_force_cfd(i).period*sqrt(2*g/B);
   
   cutdata_force_cfd(i).Mz_starboard_nondim=(cutdata_force_cfd(i).Fz_starboard*l_bb/2)/(rho*A*(l_bb^2)*(2*g/B));
   cutdata_force_cfd(i).Mz_starboard_nondim_mean=(abs(mean(findpeaks(cutdata_force_cfd(i).Mz_starboard_nondim,cutdata_force_cfd(i).t_postproc,'MinPeakDistance',cutdata_force_cfd(i).period-0.1)))+abs(mean(findpeaks(-cutdata_force_cfd(i).Mz_starboard_nondim,cutdata_force_cfd(i).t_postproc,'MinPeakDistance',cutdata_force_cfd(i).period-0.1))))/2;

   cutdata_force_cfd(i).KC=R_bb*cutdata_force_cfd(i).amplitude*(pi/180)*pi/l_bb;
   
   cutdata_force_cfd(i).eta4loc_sb=-R_bb*cutdata_force_cfd(i).eta4_imposed*pi/180;
   cutdata_force_cfd(i).eta4loc_p=R_bb*cutdata_force_cfd(i).eta4_imposed*pi/180; 
   
   cutdata_force_cfd(i).eta4dotloc_sb=gradient(cutdata_force_cfd(i).eta4loc_sb,dt2); 
   cutdata_force_cfd(i).eta4dotloc_p=gradient(cutdata_force_cfd(i).eta4loc_p,dt2); 
   
   cutdata_force_cfd(i).eta4dotdotloc_sb=gradient(cutdata_force_cfd(i).eta4dotloc_sb,dt2); 
   cutdata_force_cfd(i).eta4dotdotloc_p=gradient(cutdata_force_cfd(i).eta4dotloc_p,dt2);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Bilge boxes post-processing

%% Local motion and force new variable declaration (just for shortening the formula below)
time_bb=cutdata_force_cfd(i).t_postproc;

pos_sb=cutdata_force_cfd(i).eta4loc_sb;
vel_sb=cutdata_force_cfd(i).eta4dotloc_sb;
acc_sb=cutdata_force_cfd(i).eta4dotdotloc_sb;

pos_p=cutdata_force_cfd(i).eta4loc_p;
vel_p=cutdata_force_cfd(i).eta4dotloc_p;
acc_p=cutdata_force_cfd(i).eta4dotdotloc_p;

Fz_sb=cutdata_force_cfd(i).Fz_starboard;
Fz_p=cutdata_force_cfd(i).Fz_port;

%% Local added-mass and damping coefficient extraction 
   cutdata_force_cfd(i).a33_bb_starboard=...
   trapz(time_bb,Fz_sb.*acc_sb)./trapz(time_bb,acc_sb.*acc_sb)./...
   (rho*pi*(l_bb/2)^2); 
   
   cutdata_force_cfd(i).a33_bb_port=...
   trapz(time_bb,Fz_p.*acc_p)./trapz(time_bb,acc_p.*acc_p)./...
   (rho*pi*(l_bb/2)^2); 
   
   cutdata_force_cfd(i).b33_bb_starboard=...
   trapz(time_bb,Fz_sb.*vel_sb)./trapz(time_bb,vel_sb.*vel_sb).*...
   (sqrt(l_bb/(2*g))/(rho*A_bb));
   
   cutdata_force_cfd(i).b33_bb_port=...
   trapz(time_bb,Fz_p.*vel_p)./trapz(time_bb,vel_p.*vel_p).*...
   (sqrt(l_bb/(2*g))/(rho*A_bb));   

end
end